/**
 * Copyright (c) 2014,Egret-Labs.org
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the Egret-Labs.org nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY EGRET-LABS.ORG AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL EGRET-LABS.ORG AND CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
var Main = (function (_super) {
    __extends(Main, _super);
    function Main() {
        _super.call(this);
        this.addEventListener(egret.Event.ADDED_TO_STAGE, this.onAddToStage, this);
        egret.ExternalInterface.addCallback("setScreenWH", this.setScreenWHFromNative);
        egret.ExternalInterface.addCallback("setLanguages", this.setLanguagesFromNative);
        Main.main = this;
    }
    var __egretProto__ = Main.prototype;
    __egretProto__.onAddToStage = function (event) {
        //注入自定义的素材解析器
        egret.Injector.mapClass("egret.gui.IAssetAdapter", AssetAdapter);
        //加载皮肤主题配置文件,可以手动修改这个文件。替换默认皮肤。
        egret.gui.Theme.load("resource/theme.thm");
        //初始化Resource资源加载库
        RES.addEventListener(RES.ResourceEvent.CONFIG_COMPLETE, this.onConfigComplete, this);
        RES.loadConfig("resource/resource.json", "resource/");
        if (navigator) {
            var ua = navigator.userAgent.toLowerCase();
            egret.Logger.info("test", "test");
            console.log("language", navigator.systemLanguage);
            console.log("ua ", ua);
        }
        if (window) {
            console.log("width,height ", window.innerWidth, " ", window.innerHeight);
            console.log("width,height ", this.stage.stageWidth, " ", this.stage.stageHeight);
            console.log("width,height ", this.stage.width, " ", this.stage.height);
            this.setScreenWH(window.innerWidth, window.innerHeight);
        }
        else {
            egret.ExternalInterface.call("onAddedToStage", "");
        }
    };
    __egretProto__.setScreenWHFromNative = function (value) {
        var w = parseInt(value.split(",")[0]);
        var h = parseInt(value.split(",")[1]);
        Main.main.setScreenWH(w, h);
        egret.ExternalInterface.call("TestExternalInterface", w + ",   " + h);
    };
    __egretProto__.setLanguagesFromNative = function (value) {
        egret.LanguageUtil.lanuage = value;
    };
    __egretProto__.setScreenWH = function (sw, sh) {
        var screenWidth = sw;
        var screenHeight = sh;
        if (screenWidth / egret.UIDef.GAME_WIDTH > screenHeight / egret.UIDef.GAME_HEIGHT) {
            this.scaleY = this.scaleX = screenHeight / egret.UIDef.GAME_HEIGHT;
            this.x = (screenWidth - egret.UIDef.GAME_WIDTH * this.scaleX) / 2;
            this.y = (screenHeight - egret.UIDef.GAME_HEIGHT * this.scaleY) / 2;
        }
        else {
            this.scaleY = this.scaleX = screenWidth / egret.UIDef.GAME_WIDTH;
            this.x = (screenWidth - egret.UIDef.GAME_WIDTH * this.scaleX) / 2;
            this.y = (screenHeight - egret.UIDef.GAME_HEIGHT * this.scaleY) / 2;
        }
        egret.UIDef.screen_height = screenHeight;
        egret.UIDef.screen_width = screenWidth;
        egret.UIDef.root_y = this.y;
        egret.UIDef.gameScale = this.scaleY;
    };
    __egretProto__.setScreenWHNative = function (sw, sh) {
        this.setScreenWH(sw, sh);
    };
    /**
     * 配置文件加载完成,开始预加载preload资源组。
     */
    __egretProto__.onConfigComplete = function (event) {
        RES.removeEventListener(RES.ResourceEvent.CONFIG_COMPLETE, this.onConfigComplete, this);
        RES.addEventListener(RES.ResourceEvent.GROUP_COMPLETE, this.onResourceLoadComplete, this);
        RES.addEventListener(RES.ResourceEvent.GROUP_PROGRESS, this.onResourceProgress, this);
        RES.setMaxLoadingThread(5);
        RES.loadGroup("preload");
        RES.loadGroup("secload");
        RES.loadGroup("start_scene");
        RES.loadGroup("select_scene");
        RES.loadGroup("main_scene");
        RES.loadGroup("talent_scene");
    };
    /**
     * preload资源组加载完成
     */
    __egretProto__.onResourceLoadComplete = function (event) {
        if (event.groupName == "preload") {
            //设置加载进度界面
            this.loadingView = LoadingUI.getInstance();
            this.addChild(this.loadingView);
            this.loadingView.x = (egret.UIDef.GAME_WIDTH - 1044) / 2;
            this.loadingView.y = (egret.UIDef.GAME_HEIGHT - 783) / 2;
        }
        else if (event.groupName == "secload") {
        }
        else if (event.groupName == "talent_scene") {
            //this.removeChild(this.loadingView);
            RES.removeEventListener(RES.ResourceEvent.GROUP_COMPLETE, this.onResourceLoadComplete, this);
            RES.removeEventListener(RES.ResourceEvent.GROUP_PROGRESS, this.onResourceProgress, this);
            this.startGame();
        }
    };
    /**
     * preload资源组加载进度
     */
    __egretProto__.onResourceProgress = function (event) {
        if (event.groupName == "select_scene") {
            this.loadingView.setProgress(event.itemsLoaded, event.itemsTotal);
        }
    };
    /**
     * 创建场景界面
     */
    __egretProto__.startGame = function () {
        //egret.Profiler.getInstance().run();
        this.guiLayer = new egret.gui.UIStage();
        this.addChild(this.guiLayer);
        this.guiLayer.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onStageTap, this);
        this.sceneGroup = new egret.gui.Group();
        this.guiLayer.addElement(this.sceneGroup);
        egret.SceneUIUtil.setSceneRoot(this.sceneGroup);
        this.gameInitiator = new egret.GameInitiator();
        this.gameInitiator.startup();
        //this.scaleX = this.scaleY = 0.5;
        //this.addChild(new StartScene());
        //游戏场景层，游戏场景相关内容可以放在这里面。
        //this.gameLayer = new egret.DisplayObjectContainer();
        //this.addChild(this.gameLayer);
        //var bitmap:egret.Bitmap = new egret.Bitmap();
        //bitmap.texture = RES.getRes("bgImage");
        //this.gameLayer.addChild(bitmap);
        ////GUI的组件必须都在这个容器内部,UIStage会始终自动保持跟舞台一样大小。
        //this.guiLayer = new egret.gui.UIStage();
        //this.addChild(this.guiLayer);
        //var button:egret.gui.Button = new egret.gui.Button();
        //button.horizontalCenter = 0;
        //button.verticalCenter = 0;
        //button.label = "点击弹窗";
        //button.addEventListener(egret.TouchEvent.TOUCH_TAP,this.onButtonClick,this);
        ////在GUI范围内一律使用addElement等方法替代addChild等方法。
        //this.guiLayer.addElement(button);
    };
    __egretProto__.onStageTap = function (event) {
        if (event.target instanceof egret.gui.Button || event.target instanceof egret.gui.ToggleButton) {
            egret.SoundUtil.playEffect("Button");
        }
    };
    //private onButtonClick(event:egret.TouchEvent):void{
    //    egret.gui.Alert.show("这是一个GUI弹窗!","弹窗")
    //}
    __egretProto__.setUrlParam = function (param) {
        if (param != "" && param != null) {
            egret.Config.Sheet_Url = param;
        }
    };
    return Main;
})(egret.DisplayObjectContainer);
Main.prototype.__class__ = "Main";
