var egret;
(function (egret) {
    var Area = (function (_super) {
        __extends(Area, _super);
        function Area() {
            _super.call(this);
            this._sysGame = egret.SysGame.getInstance();
            this._hasMoveToOther = false;
        }
        var __egretProto__ = Area.prototype;
        Object.defineProperty(__egretProto__, "fightUnit", {
            get: function () {
                return this._fightUnit;
            },
            set: function (value) {
                this._fightUnit = value;
                this.dispatchEvent(new egret.CusEvent(egret.GameEventType.AREA_FIGHT_CHANGE));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "cusSpeciesCount", {
            get: function () {
                return this._cusSpeciesCount;
            },
            set: function (value) {
                this._cusSpeciesCount = value;
                if (this._cusSpeciesCount < 0)
                    this._cusSpeciesCount = 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "cusSpeciesCountShow", {
            get: function () {
                return this._cusSpeciesCountShow;
            },
            set: function (value) {
                this._cusSpeciesCountShow = value;
                if (this._cusSpeciesCountShow < 0)
                    this._cusSpeciesCountShow = 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "initSpecies", {
            get: function () {
                return this._initSpecies;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "condition", {
            get: function () {
                return this._condition;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "info", {
            get: function () {
                return this._info;
            },
            set: function (value) {
                this._info = value;
                this.initArea();
            },
            enumerable: true,
            configurable: true
        });
        __egretProto__.initArea = function () {
            this._condition = new egret.Condition();
            this.condition.AQI = this.info.initAQI;
            this.condition.meat = this.info.initMeat;
            this.condition.O2 = this.info.initO2;
            this.condition.plant = this.info.initPlant;
            this.condition.sun = this.info.initSun;
            this.condition.temperature = this.info.initTemp;
            this.condition.water = this.info.initWater;
            this._initSpecies = new egret.Species();
            this.initSpecies.info = egret.SheetUtil.getSpeciesInfo(this.info.initSpecies);
            //			initSpecies.count = info.initSpeciesCount;
            this.cusSpeciesCount = 0;
            this.cusSpeciesCountShow = 0;
            this.checkParams(0);
        };
        __egretProto__.startBreed = function (count, isMove) {
            if (count === void 0) { count = 0; }
            if (isMove === void 0) { isMove = false; }
            if (this.cusSpeciesCount > 0)
                return false;
            this.cusSpeciesCountShow = this.cusSpeciesCount = count;
            this.checkParams(egret.SysGame.getInstance().gameData.passSec);
            if (isMove) {
                if (!egret.SysGame.getInstance().moveArea)
                    egret.SysGame.getInstance().moveArea = this;
                egret.SysGame.getInstance().executeFixTips(egret.SysGame.getInstance().getFixTipsInfos(7)[0]);
                this.dispatchEvent(new egret.CusEvent(egret.GameEventType.SPECIES_MoveTo_Area));
            }
            return true;
        };
        __egretProto__.gameRunning = function () {
            this.cusSpeciesCountShow += this._curBreed;
            //if (this.cusSpeciesCountShow > this.cusSpeciesCount) {
            //    this.cusSpeciesCountShow = this.cusSpeciesCount;
            //}
            if (this._sysGame.gameData.cusSpecisCountShow > egret.Def.MAX_NUM_SPECIES) {
                this.cusSpeciesCountShow = egret.Def.MAX_NUM_SPECIES - (this._sysGame.gameData.cusSpecisCountShow - this.cusSpeciesCountShow);
            }
            if (this.cusSpeciesCount <= 0) {
                this.cusSpeciesCountShow = 0;
            }
        };
        __egretProto__.passSecTime = function (sec) {
            if (sec === void 0) { sec = 0; }
            this.checkParams(sec);
            if (this.cusSpeciesCount + this._curBreed > this.info.maxBreed) {
                this.cusSpeciesCount = this.info.maxBreed;
            }
            else {
                if (this.cusSpeciesCount > this.info.maxBreed * this._sysGame.getCommonValue1(egret.CommonInfoType.MoveToOtherRate)) {
                    this.moveToOtherArea();
                    if (!this._hasMoveToOther) {
                        this._hasMoveToOther = true;
                        this._sysGame.dispatchEvent(new egret.CusEvent(egret.GameEventType.AREA_BREED_MAX, this)); //�������״�Ǩ���¼�
                    }
                }
            }
        };
        __egretProto__.moveToOtherArea = function () {
            var i = 0;
            var cusSpecies = this._sysGame.gameData.cusSpecies;
            var ran;
            var toArea;
            var a = 0.5 * 0.85;
            var b = 0.5 * 1.15;
            var moveCount = 0;
            if (cusSpecies.liveType == egret.Def.LIVE_TYPE_BOTH) {
                for (i = 0; i < this.info.moveArea2.length; ++i) {
                    ran = Math.random();
                    if (ran < this.info.moveRate2[i]) {
                        toArea = this._sysGame.gameData.getArea(this.info.moveArea2[i]);
                        moveCount = this.cusSpeciesCount * a + Math.random() * (b - a);
                        if (toArea.startBreed(moveCount, true))
                            this.cusSpeciesCount -= moveCount;
                    }
                }
            }
            else {
                for (i = 0; i < this.info.moveArea.length; ++i) {
                    ran = Math.random();
                    if (ran < this.info.moveRate[i]) {
                        toArea = this._sysGame.gameData.getArea(this.info.moveArea[i]);
                        moveCount = this.cusSpeciesCount * a + Math.random() * (b - a);
                        if (toArea.startBreed(moveCount, true))
                            this.cusSpeciesCount -= moveCount;
                    }
                }
            }
        };
        __egretProto__.checkParams = function (passSec) {
            if (passSec === void 0) { passSec = 0; }
            var breedPerSec;
            if (this.cusSpeciesCount > 0) {
                if (passSec <= egret.SheetUtil.getPeriodInfo(egret.Def.PERIOD_SanDie_Final).time - 1) {
                    this.cusSpeciesCount = this.getSpeCount1(this.cusSpeciesCount, passSec);
                    breedPerSec = this.getSpeCount1(this.cusSpeciesCount, passSec + 1) - this.cusSpeciesCount;
                }
                else {
                    breedPerSec = this.getSpeCountPerSec(this.cusSpeciesCount, passSec);
                    this.cusSpeciesCount += breedPerSec;
                }
                if (this._sysGame.gameData.cusSpecisCount > egret.Def.MAX_NUM_SPECIES) {
                    this.cusSpeciesCount = egret.Def.MAX_NUM_SPECIES - (this._sysGame.gameData.cusSpecisCount - this.cusSpeciesCount);
                }
                this.cusSpeciesCountShow = this.cusSpeciesCount;
                this._curBreed = breedPerSec * this._sysGame.getRunningRate();
            }
            else {
                this._curBreed = 0;
            }
        };
        __egretProto__.getSpeCount1 = function (curCount, curSec) {
            if (curSec === void 0) { curSec = 0; }
            var cusSpecies = this._sysGame.gameData.cusSpecies;
            if (curSec <= egret.SheetUtil.getPeriodInfo(egret.Def.PERIOD_SanDie_Final).time)
                return curCount + Math.ceil(curCount * (this._condition.getBreedRate(cusSpecies) + cusSpecies.info.breedRate + cusSpecies.breedRate + egret.SysGame.getInstance().talentEffect.breedRate + 1) * 2 * (this._sysGame.getCommonValue1(egret.CommonInfoType.GameSectionABreedRate) - 3 * curSec) / 10000);
            return 0;
        };
        __egretProto__.getSpeCountPerSec = function (curCount, curSec) {
            if (curSec === void 0) { curSec = 0; }
            var cusSpecies = this._sysGame.gameData.cusSpecies;
            if (curSec <= egret.SheetUtil.getPeriodInfo(egret.Def.PERIOD_ZhuLuo_Final).time)
                return Math.ceil(curCount * (this._condition.getBreedRate(cusSpecies) + cusSpecies.info.breedRate + cusSpecies.breedRate + egret.SysGame.getInstance().talentEffect.breedRate + 1) * 2 * this._sysGame.getCommonValue1(egret.CommonInfoType.GameSectionBBreedRate) / 10000);
            else
                return Math.ceil(curCount * (this._condition.getBreedRate(cusSpecies) + cusSpecies.info.breedRate + cusSpecies.breedRate + egret.SysGame.getInstance().talentEffect.breedRate + 1) * 2 * this._sysGame.getCommonValue1(egret.CommonInfoType.GameSectionCBreedRate) / 10000);
        };
        return Area;
    })(egret.EventDispatcher);
    egret.Area = Area;
    Area.prototype.__class__ = "egret.Area";
})(egret || (egret = {}));
