var egret;
(function (egret) {
    var Condition = (function (_super) {
        __extends(Condition, _super);
        function Condition() {
            _super.call(this);
            this._sun = 0;
            this._temperature = 0;
            this._O2 = 0;
            this._AQI = 0;
            this._water = 0;
            this._plant = 0;
            this._meat = 0;
        }
        var __egretProto__ = Condition.prototype;
        Object.defineProperty(__egretProto__, "meat", {
            get: function () {
                return this._meat;
            },
            set: function (value) {
                this._meat = value;
                if (this._meat > 200)
                    this._meat = 200;
                else if (this._meat < 0)
                    this._meat = 0;
                this.dispatchEvent(new egret.CusEvent(egret.GameEventType.CONDITION_CHANGE));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "meatEffect", {
            get: function () {
                return this._meat > 100 ? 200 - this._meat : this._meat;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "plant", {
            get: function () {
                return this._plant;
            },
            set: function (value) {
                this._plant = value;
                if (this._plant > 200)
                    this._plant = 200;
                else if (this._plant < 0)
                    this._plant = 0;
                this.dispatchEvent(new egret.CusEvent(egret.GameEventType.CONDITION_CHANGE));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "plantEffect", {
            get: function () {
                return this._plant > 100 ? 200 - this._plant : this._plant;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "water", {
            get: function () {
                return this._water;
            },
            set: function (value) {
                this._water = value;
                if (this._water > 200)
                    this._water = 200;
                else if (this._water < 0)
                    this._water = 0;
                this.dispatchEvent(new egret.CusEvent(egret.GameEventType.CONDITION_CHANGE));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "waterEffect", {
            get: function () {
                return this._water > 100 ? 200 - this._water : this._water;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "AQI", {
            get: function () {
                return this._AQI;
            },
            set: function (value) {
                this._AQI = value;
                if (this._AQI > 200)
                    this._AQI = 200;
                else if (this._AQI < 0)
                    this._AQI = 0;
                this.dispatchEvent(new egret.CusEvent(egret.GameEventType.CONDITION_CHANGE));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "AQIEffect", {
            get: function () {
                return this._AQI > 100 ? 200 - this._AQI : this._AQI;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "O2", {
            get: function () {
                return this._O2;
            },
            set: function (value) {
                this._O2 = value;
                if (this._O2 > 200)
                    this._O2 = 200;
                else if (this._O2 < 0)
                    this._O2 = 0;
                this.dispatchEvent(new egret.CusEvent(egret.GameEventType.CONDITION_CHANGE));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "O2Effect", {
            get: function () {
                return this._O2 > 100 ? 200 - this._O2 : this._O2;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "temperature", {
            get: function () {
                return this._temperature;
            },
            set: function (value) {
                this._temperature = value;
                if (this._temperature > 200)
                    this._temperature = 200;
                else if (this._temperature < 0)
                    this._temperature = 0;
                this.dispatchEvent(new egret.CusEvent(egret.GameEventType.CONDITION_CHANGE));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "temperatureEffect", {
            get: function () {
                return this._temperature > 100 ? 200 - this._temperature : this._temperature;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "sun", {
            get: function () {
                return this._sun;
            },
            set: function (value) {
                this._sun = value;
                if (this._sun > 200)
                    this._sun = 200;
                else if (this._sun < 0)
                    this._sun = 0;
                this.dispatchEvent(new egret.CusEvent(egret.GameEventType.CONDITION_CHANGE));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "sunEffect", {
            get: function () {
                return this._sun > 100 ? 200 - this._sun : this._sun;
            },
            enumerable: true,
            configurable: true
        });
        __egretProto__.getBreedRate = function (species) {
            var rate = 0;
            var talentEffect = egret.SysGame.getInstance().talentEffect;
            rate += this.getOneRate(this.sunEffect + talentEffect.sun) * 16;
            rate += this.getOneRate(this.temperatureEffect + talentEffect.temp) * 16;
            rate += this.getOneRate(this.O2Effect + talentEffect.O2) * 8;
            rate += this.getOneRate(this.waterEffect + talentEffect.water) * 8;
            if (species.eatType == egret.Def.EAT_TYPE_BOTH && species.eatType == egret.Def.EAT_TYPE_PLANT)
                rate += this.getOneRate(this.plantEffect + talentEffect.plant) * 8;
            if (species.eatType == egret.Def.EAT_TYPE_BOTH && species.eatType == egret.Def.EAT_TYPE_MEET)
                rate += this.getOneRate(this.meatEffect + talentEffect.meat) * 8;
            rate += this.getOneRate(this.AQIEffect + talentEffect.AQI) * 8;
            return rate;
        };
        __egretProto__.getOneRate = function (value) {
            if (value > 100)
                value = 200 - value;
            return (-0.00000014 * value * value + 0.000083 * value - 0.0038);
        };
        __egretProto__.getLive = function (species) {
            var rate = 0;
            var talentEffect = egret.SysGame.getInstance().talentEffect;
            rate += this.getOneRate(this.O2Effect + talentEffect.O2) * 16;
            rate += this.getOneRate(this.waterEffect + talentEffect.water) * 16;
            if (species.eatType == egret.Def.EAT_TYPE_BOTH && species.eatType == egret.Def.EAT_TYPE_PLANT)
                rate += this.getOneRate(this.plantEffect + talentEffect.plant) * 16;
            if (species.eatType == egret.Def.EAT_TYPE_BOTH && species.eatType == egret.Def.EAT_TYPE_MEET)
                rate += this.getOneRate(this.meatEffect + talentEffect.meat) * 16;
            return rate;
        };
        __egretProto__.getSocial = function (species) {
            var rate = 0;
            var talentEffect = egret.SysGame.getInstance().talentEffect;
            rate += this.getOneRate(this.AQIEffect + talentEffect.AQI) * 16;
            return rate;
        };
        __egretProto__.getDNA = function () {
            var rate = 0;
            var talentEffect = egret.SysGame.getInstance().talentEffect;
            rate += this.getOneRate(this.sunEffect + talentEffect.sun) * 16;
            return rate;
        };
        return Condition;
    })(egret.EventDispatcher);
    egret.Condition = Condition;
    Condition.prototype.__class__ = "egret.Condition";
})(egret || (egret = {}));
