var egret;
(function (egret) {
    var FightUnit = (function (_super) {
        __extends(FightUnit, _super);
        function FightUnit() {
            _super.call(this);
            this.lastTime = 0;
            this.cusAttakTimes = 0;
            this.attakTimes = 0;
        }
        var __egretProto__ = FightUnit.prototype;
        Object.defineProperty(__egretProto__, "isOver", {
            get: function () {
                return this._isOver;
            },
            set: function (value) {
                this._isOver = value;
                this.dispatchEvent(new egret.CusEvent(egret.GameEventType.FIGHT_OVER_CHANGE));
            },
            enumerable: true,
            configurable: true
        });
        __egretProto__.setData = function (areaPm, info) {
            this.area = areaPm;
            if (this.area) {
                this.area.fightUnit = this;
            }
            this.cusSpecies = egret.SysGame.getInstance().gameData.cusSpecies;
            this.species = new egret.Species();
            this.species.info = info;
            this.lastTime = 0;
            this.cusAttakTimes = 0;
            this.attakTimes = 0;
            this.isOver = false;
            this.hasSkill = false;
            this.dispatchEvent(new egret.CusEvent(egret.GameEventType.FIGHT_UNIT_INIT));
        };
        __egretProto__.executeFight = function (time, isNeedRandom) {
            if (time === void 0) { time = 0; }
            if (isNeedRandom === void 0) { isNeedRandom = true; }
            if (this.isOver)
                return;
            var talentEffect = egret.SysGame.getInstance().talentEffect;
            this.lastTime += time;
            var cusAttakSpeed = (1000 / (500 + this.cusSpecies.info.social + this.cusSpecies.social + talentEffect.social) * 1000 / (1 + this.cusSpecies.socialRate + talentEffect.socialRate + egret.SysGame.getInstance().getShopSocial())) >> 0;
            //var attakSpeed:number = (1000/(500+this.species.info.social)*1000/(1+this.species.socialRate))>>0;
            var attakSpeed = (1000 / (500 + this.species.info.social) * 1000) >> 0;
            if (this.lastTime > 5 * 1000 && !this.hasSkill) {
                this.hasSkill = true;
                var hasSkillTalents = [];
                for (var i = 0; i < egret.SysGame.getInstance().talentDic.length; ++i) {
                    var talent = egret.SysGame.getInstance().talentDic[i];
                    if (!talent)
                        continue;
                    if (talent.info.skillID != 0 && egret.SheetUtil.getSkillInfo(talent.info.skillID).fightDesc != "0") {
                        hasSkillTalents.push(talent);
                    }
                }
                if (hasSkillTalents.length > 0) {
                    talent = hasSkillTalents[(Math.random() * hasSkillTalents.length) >> 0];
                    egret.SysGame.getInstance().dispatchEvent(new egret.CusEvent(egret.GameEventType.FIGHT_UNIT_FIGHT_SKILL, { skillInfo: egret.SheetUtil.getSkillInfo(talent.info.skillID), enemyName: egret.LanguageUtil.getLanguage(this.species.info.name) }));
                }
            }
            if (this.lastTime >= cusAttakSpeed * (this.cusAttakTimes + 1)) {
                var randomValue = 0;
                if (isNeedRandom) {
                    randomValue = Math.random() * egret.SysGame.getInstance().getCommonValue1(egret.CommonInfoType.FightRandom);
                }
                var cusAttak = (this.cusSpecies.info.fight + this.cusSpecies.fight + talentEffect.fight) * (1 + this.cusSpecies.fightRate + talentEffect.fightRate + egret.SysGame.getInstance().getShopFight()) + randomValue;
                this.cusAttakTimes++;
                this.species.count -= cusAttak - this.species.info.live;
                if (this.species.count <= 0) {
                    this.species.count = 0;
                    this.isOver = true;
                }
                this.dispatchEvent(new egret.CusEvent(egret.GameEventType.FIGHT_UNIT_FIGHT));
            }
            if (this.lastTime >= attakSpeed * (this.attakTimes + 1)) {
                var cusDefense = (this.cusSpecies.info.live + this.cusSpecies.live + talentEffect.live) * (1 + this.cusSpecies.liveRate + talentEffect.liveRate + egret.SysGame.getInstance().getShopLive());
                this.attakTimes++;
                var countKill = this.species.info.fight + this.species.fight - cusDefense;
                if (this.area) {
                    this.area.cusSpeciesCount -= countKill;
                    if (this.area.cusSpeciesCount <= 0) {
                        this.area.cusSpeciesCount = 0;
                        this.area.cusSpeciesCountShow = 0;
                        this.isOver = true;
                    }
                }
                else {
                    var hasCountAreaNum = 0;
                    var area;
                    countKill = countKill * (1 - egret.SysGame.getInstance().getOverDefence());
                    egret.SysGame.getInstance().gameData.killCusSpecies(countKill);
                    for (var i = 0; i < egret.SysGame.getInstance().gameData.areas.length; i++) {
                        area = egret.SysGame.getInstance().gameData.areas[i];
                        if (area.cusSpeciesCount > 0)
                            hasCountAreaNum++;
                    }
                    if (hasCountAreaNum == 0) {
                        this.isOver = true;
                    }
                }
            }
        };
        return FightUnit;
    })(egret.EventDispatcher);
    egret.FightUnit = FightUnit;
    FightUnit.prototype.__class__ = "egret.FightUnit";
})(egret || (egret = {}));
