var egret;
(function (egret) {
    var GameData = (function (_super) {
        __extends(GameData, _super);
        function GameData() {
            _super.call(this);
            this.cusSpecies = new egret.CusSpecies();
            this._DNA = 2525;
            //public talents:Array<Talent>;
            this._passTime = 0;
            this._passSec = 0;
            this.DNARate = 1;
            this._overState = false;
            this.overFightUnit = new egret.FightUnit();
            this.news = [];
            this.appearSpecies = [];
            this.mode = egret.Def.Mode_SanDieJi;
            this.difficulty = egret.Def.DIFF_EASY;
            this.initGameData();
        }
        var __egretProto__ = GameData.prototype;
        Object.defineProperty(__egretProto__, "overState", {
            get: function () {
                return this._overState;
            },
            set: function (value) {
                this._overState = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "areas", {
            get: function () {
                return this._areas;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "passTime", {
            get: function () {
                return this._passTime;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "DNA", {
            get: function () {
                return 2525;
            },
            set: function (value) {
                var old = this._DNA;
                this._DNA = 2525;
                var firstDNAFixInfo = egret.SysGame.getInstance().getFixTipsInfos(4)[0];
                if (firstDNAFixInfo && this._DNA >= firstDNAFixInfo.param) {
                    egret.SysGame.getInstance().executeFixTips(firstDNAFixInfo);
                }
                this.dispatchEvent(new egret.CusEvent(egret.GameEventType.DNA_CHANGE, old));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "curPeriod", {
            get: function () {
                for (var i = egret.Def.PERIOD_BEGIN; i < egret.Def.PERIOD_END; ++i) {
                    var periodInfo = egret.SheetUtil.getPeriodInfo(i);
                    if (this.passSec <= periodInfo.time) {
                        return i;
                    }
                }
                return egret.Def.PERIOD_END - 1;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "passSec", {
            get: function () {
                return this._passSec;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "cusSpecisCount", {
            get: function () {
                var count = 0;
                var length = this._areas.length;
                for (var i = 0; i < length; i++) {
                    var area = this._areas[i];
                    count += area.cusSpeciesCount;
                }
                return count;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "cusSpecisCountShow", {
            get: function () {
                var count = 0;
                var length = this._areas.length;
                for (var i = 0; i < length; i++) {
                    var area = this._areas[i];
                    count += area.cusSpeciesCountShow;
                }
                return Math.ceil(count);
            },
            enumerable: true,
            configurable: true
        });
        __egretProto__.initGameData = function () {
            var ary;
            var areaInfo;
            var area;
            //var talentInfo:TalentInfo;
            //var talent:Talent;
            this.overState = false;
            this.news.length = 0;
            egret.SheetUtil.initAreaInfo();
            ary = egret.SheetUtil.arrAreaInfo;
            this._areas = [];
            for (var i = 0; i < ary.length; ++i) {
                areaInfo = ary[i];
                area = new egret.Area();
                area.info = areaInfo;
                this._areas[i] = area;
            }
            this.appearSpecies.length = 0;
            //SheetUtil.initTalentInfo();
            //ary = SheetUtil.arrTalentInfo;
            //this.talents = [];
            //for(i=0; i<ary.length; ++i){
            //	talentInfo = ary[i];
            //	talent = new Talent();
            //	talent.info = talentInfo;
            //	this.talents[i] = talent;
            //}
            this._passTime = 0;
            this._passSec = 0;
        };
        __egretProto__.setModeDiff = function (mode, diff) {
            this.mode = mode;
            this.difficulty = diff;
            this.modeDiffInfo = egret.SysGame.getInstance().getModeDiffInfo(this.mode, this.difficulty);
        };
        __egretProto__.gameRunning = function (time) {
            var area;
            this._passTime += time;
            if ((this._passTime / 1000) >> 0 > this._passSec) {
                var oldPeriod = this.curPeriod;
                this._passSec = (this._passTime / 1000) >> 0;
                if (this.overState) {
                    //刚进入灭世状态
                    egret.SysGame.getInstance().executeFixTips(egret.SysGame.getInstance().getFixTipsInfos(11)[0]);
                }
                var firstClickFixInfo = egret.SysGame.getInstance().getFixTipsInfos(6)[0];
                if (egret.SysGame.getInstance().firstClickTalentTime != 0 && firstClickFixInfo && this.passSec - egret.SysGame.getInstance().firstClickTalentTime >= firstClickFixInfo.param) {
                    egret.SysGame.getInstance().executeFixTips(firstClickFixInfo);
                }
                if (!this.overState) {
                    var length = this._areas.length;
                    for (var i = 0; i < length; i++) {
                        area = this._areas[i];
                        area.passSecTime(this._passSec);
                    }
                    var dnaPerTime = egret.SysGame.getInstance().getCommonValue1(egret.CommonInfoType.GetDNAPerTime);
                    if (this._passSec % dnaPerTime == 0) {
                        this.addDNAPerTime();
                    }
                    if (this.curPeriod == egret.Def.PERIOD_Over_State || this.cusSpecisCount >= egret.Def.MAX_NUM_SPECIES) {
                        this.overState = true;
                        this.checkCusSpeciesChange(-1);
                        this.rewardTalent();
                        this.overFightUnit.setData(null, egret.SheetUtil.getSpeciesInfo(this.modeDiffInfo.bossID));
                    }
                    var startRandomTime = egret.SysGame.getInstance().getCommonValue1(egret.CommonInfoType.GameStartTime);
                    if (this._passSec - startRandomTime > 0 && (this._passSec - startRandomTime) % 30 == 0) {
                        egret.SysGame.getInstance().triggerRandomEventEffect();
                    }
                    else if (this._passSec - startRandomTime - 15 > 0 && (this._passSec - startRandomTime - 15) % 30 == 0) {
                        egret.SysGame.getInstance().triggerRandomEventNoEffect();
                    }
                }
                else {
                    var startRandomTime = egret.SysGame.getInstance().getCommonValue1(egret.CommonInfoType.GameStartTime);
                    if (this._passSec - startRandomTime > 0 && (this._passSec - startRandomTime) % 10 == 0) {
                        egret.SysGame.getInstance().triggerRandomEventOverState();
                    }
                }
                if (this.curPeriod != oldPeriod && !this.overState) {
                    this.checkCusSpeciesChange(oldPeriod);
                    this.rewardTalent();
                }
                var begFixInfo = egret.SysGame.getInstance().getFixTipsInfos(3)[0];
                if (begFixInfo && this._passSec == begFixInfo.param) {
                    egret.SysGame.getInstance().executeFixTips(begFixInfo);
                }
                else {
                    if (!this.overState) {
                        var overTime = egret.SheetUtil.getPeriodInfo(egret.Def.PERIOD_BaiE_Final).time + 1;
                        var checkFixInfos = egret.SysGame.getInstance().getFixTipsInfos(10);
                        for (var o1 = 0; o1 < checkFixInfos.length; ++o1) {
                            var fixInfo = checkFixInfos[o1];
                            if (this.passSec >= overTime - fixInfo.param) {
                                egret.SysGame.getInstance().executeFixTips(fixInfo);
                                break;
                            }
                        }
                    }
                }
                this.dispatchEvent(new egret.CusEvent(egret.GameEventType.GAME_PASS_SEC_CHANGE));
            }
            if (!this.overState) {
                var length1 = this._areas.length;
                for (var i1 = 0; i1 < length1; i1++) {
                    area = this._areas[i1];
                    area.gameRunning();
                }
            }
            else {
                if (!this.overFightUnit.isOver) {
                    this.overFightUnit.executeFight(time, false);
                }
                else {
                }
            }
        };
        __egretProto__.addDNAPerTime = function () {
            var addDNA = this.DNARate * (-0.00003 * this.cusSpecisCount / 10000000 * this.cusSpecisCount / 10000000 + 0.022 * this.cusSpecisCount / 10000000 + 1.783);
            this.DNA += (addDNA) >> 0;
        };
        __egretProto__.getAllArea = function () {
            return this._areas;
        };
        __egretProto__.getArea = function (tabID) {
            if (tabID === void 0) { tabID = 0; }
            var length = this._areas.length;
            for (var i = 0; i < length; i++) {
                var area = this._areas[i];
                if (area.info.tabID == tabID) {
                    return area;
                }
            }
            return null;
        };
        __egretProto__.getAreaByType = function (type) {
            if (type === void 0) { type = 0; }
            var ary = [];
            var length = this._areas.length;
            for (var i = 0; i < length; i++) {
                var area = this._areas[i];
                if (area.info.type == type) {
                    ary.push(area);
                }
            }
            return ary;
        };
        __egretProto__.getAreaByPlant = function (plateID) {
            if (plateID === void 0) { plateID = 0; }
            var ary = [];
            var length = this._areas.length;
            for (var i = 0; i < length; i++) {
                var area = this._areas[i];
                if (area.info.plateID == plateID) {
                    ary.push(area);
                }
            }
            return ary;
        };
        __egretProto__.setCusSpecies = function (liveType, eatType, initBreed, initSocial, initLive) {
            if (this.mode == egret.Def.Mode_ShiShi) {
                var max = 200;
                for (var i = 0; i < this._areas.length; ++i) {
                    var area = this._areas[i];
                    area.condition.AQI = (Math.random() * (max + 1)) >> 0;
                    area.condition.O2 = (Math.random() * (max + 1)) >> 0;
                    area.condition.sun = (Math.random() * (max + 1)) >> 0;
                    area.condition.temperature = (Math.random() * (max + 1)) >> 0;
                    area.condition.water = (Math.random() * (max + 1)) >> 0;
                    area.condition.plant = (Math.random() * (max + 1)) >> 0;
                    area.condition.meat = (Math.random() * (max + 1)) >> 0;
                }
            }
            var ran = (Math.random() * this.modeDiffInfo.initSpecies.length) >> 0;
            if (this.mode == egret.Def.Mode_ZhuLuoJi) {
                ran = eatType;
            }
            else if (this.mode == egret.Def.Mode_BaiEJi) {
                ran = liveType;
            }
            this.initSpeciesInfo = egret.SheetUtil.getSpeciesInfo(this.modeDiffInfo.initSpecies[ran]);
            this.cusSpecies.info = this.initSpeciesInfo;
            this.cusSpecies.liveType = liveType;
            this.cusSpecies.eatType = eatType;
            this.cusSpecies.breedRate = initBreed;
            this.cusSpecies.social = initSocial;
            this.cusSpecies.live = initLive;
            var initTalentStr = this.modeDiffInfo.initTalent[ran];
            if (initTalentStr != "0") {
                var arr = initTalentStr.split("_");
                for (var i = 0; i < arr.length; ++i) {
                    var talent = egret.SysGame.getInstance().getTalent(parseInt(arr[i]));
                    talent.isActive = true;
                    egret.SysGame.getInstance().recheckTalentVisible(talent);
                }
            }
            if (this.mode == egret.Def.Mode_ZhuLuoJi) {
                this._passTime = egret.SheetUtil.getPeriodInfo(egret.Def.PERIOD_SanDie_Final).time * 1000;
            }
            else if (this.mode == egret.Def.Mode_BaiEJi) {
                this._passTime = egret.SheetUtil.getPeriodInfo(egret.Def.PERIOD_ZhuLuo_Final).time * 1000;
            }
            else {
                this._passTime = 0;
            }
            this._passSec = 1 + ((this._passTime / 1000) >> 0);
        };
        __egretProto__.rewardTalent = function () {
            var canAddTalents = [];
            var talents = egret.SysGame.getInstance().talentDic;
            for (var i = 0; i < talents.length; ++i) {
                var talent = talents[i];
                if (!talent)
                    continue;
                if (talent.isUnlock && talent.isVisible && !talent.isActive) {
                    canAddTalents.push(talent);
                }
            }
            if (canAddTalents.length > 0) {
                var addTalent = canAddTalents[(Math.random() * canAddTalents.length) >> 0];
                addTalent.isActive = true;
                egret.SysGame.getInstance().recheckTalentVisible(addTalent);
                egret.SysGame.getInstance().dispatchEvent(new egret.CusEvent(egret.GameEventType.REWARD_TALENT, addTalent));
            }
        };
        __egretProto__.checkCusSpeciesChange = function (oldPeriod) {
            if (oldPeriod != -1 && oldPeriod != egret.Def.PERIOD_BaiE_Final && oldPeriod != egret.Def.PERIOD_ZhuLuo_Final && oldPeriod != egret.Def.PERIOD_SanDie_Final)
                return;
            var confirmEvoInfos = [];
            var evoInfo;
            var maxSection = 0;
            egret.SheetUtil.initEvolutionInfo();
            for (var i = 0; i < egret.SheetUtil.arrEvolutionInfo.length; ++i) {
                evoInfo = egret.SheetUtil.arrEvolutionInfo[i];
                if (this.cusSpecies.eatType != egret.Def.EAT_TYPE_BOTH && evoInfo.eatType != egret.Def.EAT_TYPE_BOTH && this.cusSpecies.eatType != evoInfo.eatType) {
                    continue;
                }
                if (this.cusSpecies.liveType != egret.Def.LIVE_TYPE_BOTH && evoInfo.liveType != egret.Def.EAT_TYPE_BOTH && this.cusSpecies.liveType != evoInfo.liveType) {
                    continue;
                }
                if (evoInfo.section <= 1 && this.curPeriod - 1 >= egret.Def.PERIOD_SanDie && this.curPeriod - 1 <= egret.Def.PERIOD_SanDie_Final || evoInfo.section <= 2 && this.curPeriod - 1 >= egret.Def.PERIOD_ZhuLuo && this.curPeriod - 1 <= egret.Def.PERIOD_ZhuLuo_Final || evoInfo.section <= 4 && this.curPeriod - 1 >= egret.Def.PERIOD_BaiE && this.curPeriod - 1 <= egret.Def.PERIOD_Over_State) {
                    var talent;
                    var confirmCount = 0;
                    talent = egret.SysGame.getInstance().getTalent(evoInfo.condition1);
                    if (talent && talent.isActive)
                        confirmCount++;
                    talent = egret.SysGame.getInstance().getTalent(evoInfo.condition2);
                    if (talent && talent.isActive)
                        confirmCount++;
                    talent = egret.SysGame.getInstance().getTalent(evoInfo.condition3);
                    if (talent && talent.isActive)
                        confirmCount++;
                    talent = egret.SysGame.getInstance().getTalent(evoInfo.condition4);
                    if (talent && talent.isActive)
                        confirmCount++;
                    talent = egret.SysGame.getInstance().getTalent(evoInfo.condition5);
                    if (talent && talent.isActive)
                        confirmCount++;
                    talent = egret.SysGame.getInstance().getTalent(evoInfo.condition6);
                    if (talent && talent.isActive)
                        confirmCount++;
                    if (evoInfo.count != -1 && confirmCount >= evoInfo.count) {
                        confirmEvoInfos.push(evoInfo);
                        if (evoInfo.section > maxSection) {
                            maxSection = evoInfo.section;
                        }
                    }
                }
            }
            for (var k = 0; k < confirmEvoInfos.length; ++k) {
                evoInfo = confirmEvoInfos[k];
                if (evoInfo.section < maxSection) {
                    confirmEvoInfos.splice(k--, 1);
                }
            }
            if (confirmEvoInfos.length > 0) {
                evoInfo = confirmEvoInfos[(Math.random() * confirmEvoInfos.length) >> 0];
                var speciesInfo = egret.SheetUtil.getSpeciesInfo(evoInfo.speciesID);
                if (this.cusSpecies.info == speciesInfo) {
                    return;
                }
                this.cusSpecies.info = speciesInfo;
                this.appearSpecies.push(speciesInfo.tabID);
                var fixInfos = egret.SysGame.getInstance().getFixTipsInfos(9);
                for (var f1 = 0; f1 < fixInfos.length; ++f1) {
                    var fixInfo = fixInfos[f1];
                    if (!this.overState && fixInfo.param == this.curPeriod || this.overState && fixInfo.param == -1) {
                        egret.SysGame.getInstance().executeFixTips(fixInfo);
                    }
                }
            }
        };
        __egretProto__.killCusSpecies = function (countKill) {
            var hasCountAreaNum = 0;
            var area;
            var killPerArea;
            var leftKillCount = countKill;
            var length = egret.SysGame.getInstance().gameData.areas.length;
            while (leftKillCount > 0) {
                hasCountAreaNum = 0;
                for (var i = 0; i < length; i++) {
                    area = egret.SysGame.getInstance().gameData.areas[i];
                    if (area.cusSpeciesCount > 0)
                        hasCountAreaNum++;
                }
                if (hasCountAreaNum == 0) {
                    break;
                }
                killPerArea = Math.ceil(leftKillCount / hasCountAreaNum);
                for (i = 0; i < length; i++) {
                    area = egret.SysGame.getInstance().gameData.areas[i];
                    if (area.cusSpeciesCount > 0) {
                        area.cusSpeciesCount -= killPerArea;
                        leftKillCount -= killPerArea;
                        if (leftKillCount < 0) {
                            area.cusSpeciesCount -= leftKillCount;
                            leftKillCount = 0;
                        }
                        if (area.cusSpeciesCount < 0) {
                            leftKillCount -= area.cusSpeciesCount;
                            area.cusSpeciesCount = 0;
                        }
                        area.cusSpeciesCountShow = area.cusSpeciesCount;
                    }
                }
            }
        };
        return GameData;
    })(egret.EventDispatcher);
    egret.GameData = GameData;
    GameData.prototype.__class__ = "egret.GameData";
})(egret || (egret = {}));
