var egret;
(function (egret) {
    var SysGame = (function (_super) {
        __extends(SysGame, _super);
        function SysGame() {
            _super.call(this);
            this._runningDelay = 35;
            this._runningSpeed = 1;
            this._fightUnits = [];
            this._curRandEvents = [];
            this._lmtCountEventIDs = [];
            this._executeRandEventTime = 0;
            this.isAutoClick = false;
            this.excutingFixTips = false;
            this.firstClickTalentTime = 0;
            this._gameTimer = new egret.Timer(this._runningDelay);
            this._gameTimer.addEventListener(egret.TimerEvent.TIMER, this.onGameRuning, this);
            if (this.getCurOpenDiff(egret.Def.Mode_SanDieJi) == -1) {
                this.setCurOpenDiff(egret.Def.Mode_SanDieJi, egret.Def.DIFF_EASY);
            }
        }
        var __egretProto__ = SysGame.prototype;
        Object.defineProperty(__egretProto__, "gameData", {
            get: function () {
                return this._gameData;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "isPause", {
            get: function () {
                return this._isPause;
            },
            set: function (value) {
                this._isPause = value;
                if (this.isPause) {
                    this._gameTimer.stop();
                }
                else {
                    if (this.state == egret.Def.GAME_STATE_START)
                        this._gameTimer.start();
                }
            },
            enumerable: true,
            configurable: true
        });
        SysGame.getInstance = function () {
            if (!SysGame._instance)
                SysGame._instance = new SysGame();
            return SysGame._instance;
        };
        Object.defineProperty(__egretProto__, "state", {
            get: function () {
                return this._state;
            },
            set: function (value) {
                this._state = value;
                if (this.state == egret.Def.GAME_STATE_OVER) {
                    this._gameTimer.stop();
                }
                this.dispatchEvent(new egret.CusEvent(egret.GameEventType.GAME_STATE_CHANGE));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "runningSpeed", {
            get: function () {
                return this._runningSpeed;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "talentDic", {
            get: function () {
                return this._talentDic;
            },
            enumerable: true,
            configurable: true
        });
        __egretProto__.initGame = function (restart) {
            if (restart === void 0) { restart = false; }
            this._soGame = egret.localStorage.getItem("Jurassic_Game_Data");
            this._gameData = new egret.GameData();
            this._fightUnits = [];
            this._curRandEvents = [];
            this._lmtCountEventIDs = [];
            this.talentEffect = new egret.TalentEffect();
            this._gameData.overFightUnit.addEventListener(egret.GameEventType.FIGHT_OVER_CHANGE, this.onOverFightOverChange, this);
            SysGame.getInstance().setRunningSpeed(1);
            this._talentDic = [];
            egret.SheetUtil.initTalentInfo();
            var length = egret.SheetUtil.arrTalentInfo.length;
            for (var i = 0; i < length; i++) {
                var talentInfo = egret.SheetUtil.arrTalentInfo[i];
                var talent = new egret.Talent();
                talent.info = talentInfo;
                talent.isUnlock = talentInfo.activeEnabled;
                if (!talentInfo.activeEnabled && this.getTalentUnlockLocal(talentInfo.tabID)) {
                    talent.isUnlock = true;
                }
                if (talentInfo.prevID.indexOf(-1) == -1) {
                    talent.isVisible = false;
                }
                else {
                    talent.isVisible = true;
                }
                talent.isActive = false;
                this._talentDic[talent.info.tabID] = talent;
            }
            if (!restart && this._soGame) {
                this.readFromSo();
            }
            else {
                this.saveToSo();
            }
            if (restart) {
                this.state = egret.Def.GAME_STATE_READY;
            }
            else {
                this._gameTimer.start();
                this.state = egret.Def.GAME_STATE_START;
            }
            this.startArea = this.moveArea = null;
            this.isAutoClick = false;
            this.firstClickTalentTime = 0;
            egret.SheetUtil.initFixTipsInfo();
            this._allFixTips = egret.SheetUtil.arrFixTipsInfo.concat();
            this.excutingFixTips = false;
        };
        __egretProto__.startFromArea = function (area) {
            if (this.state == egret.Def.GAME_STATE_READY) {
                area.startBreed(this.gameData.modeDiffInfo.initNum);
                this.startArea = area;
                this._gameTimer.start();
                this.state = egret.Def.GAME_STATE_START;
            }
        };
        __egretProto__.readFromSo = function () {
        };
        __egretProto__.saveToSo = function () {
        };
        __egretProto__.getCurOpenDiff = function (mode) {
            var str = egret.localStorage.getItem("mode_diff" + mode);
            if (str) {
                return parseInt(str);
            }
            return -1;
        };
        __egretProto__.setCurOpenDiff = function (mode, diff) {
            egret.localStorage.setItem("mode_diff" + mode, diff.toString());
        };
        __egretProto__.setCompleteModeDiff = function (mode, diff) {
            if (diff < egret.Def.DIFF_HARD) {
                this.setCurOpenDiff(mode, diff + 1);
            }
            if (mode < egret.Def.Mode_ShiShi && this.getCurOpenDiff(mode + 1) == -1) {
                this.setCurOpenDiff(mode + 1, egret.Def.DIFF_EASY);
            }
        };
        __egretProto__.onOverFightOverChange = function (event) {
            if (this.gameData.overFightUnit.isOver) {
                this.state = egret.Def.GAME_STATE_OVER;
            }
        };
        __egretProto__.setRunningSpeed = function (value) {
            this._runningSpeed = value;
        };
        __egretProto__.onGameRuning = function (event) {
            this._gameData.gameRunning(this.getOneRunningTime());
            for (var i = 0; i < this._fightUnits.length; ++i) {
                var fightUnit = this._fightUnits[i];
                fightUnit.executeFight(this.getOneRunningTime(), true);
                if (fightUnit.isOver) {
                    this._fightUnits.splice(i--, 1);
                }
            }
            if (this._curRandEvents.length > 0 && this.state != egret.Def.GAME_STATE_OVER) {
                this._executeRandEventTime -= this.getOneRunningTime();
                if (this._executeRandEventTime <= 0) {
                    this._executeRandEventTime = 5 * 1000;
                    this.executeRandomEvent(new egret.RandomEvent(this._curRandEvents.shift()));
                }
            }
            if (this.gameData.mode == egret.Def.Mode_SanDieJi) {
                if (this._gameData.passTime + this.getOneRunningTime() > egret.SheetUtil.getPeriodInfo(egret.Def.PERIOD_SanDie_Final).time * 1000 + 5 * 1000) {
                    this.state = egret.Def.GAME_STATE_OVER;
                }
            }
            else if (this.gameData.mode == egret.Def.Mode_ZhuLuoJi) {
                if (this._gameData.passTime + this.getOneRunningTime() > egret.SheetUtil.getPeriodInfo(egret.Def.PERIOD_ZhuLuo_Final).time * 1000 + 5 * 1000) {
                    this.state = egret.Def.GAME_STATE_OVER;
                }
            }
            else {
                if (this.gameData.passSec >= egret.SheetUtil.getPeriodInfo(egret.Def.PERIOD_Over_State).time) {
                    this.state = egret.Def.GAME_STATE_OVER;
                }
            }
            if (this.gameData.modeDiffInfo.aimType1 == 4) {
                if (this.gameData.cusSpecisCount < this.gameData.modeDiffInfo.aimParam1) {
                    this.state = egret.Def.GAME_STATE_OVER;
                }
            }
            this.dispatchEvent(new egret.CusEvent(egret.GameEventType.GAME_RUNNING));
        };
        __egretProto__.getOneRunningTime = function () {
            if (this.gameData.curPeriod >= egret.Def.PERIOD_BaiE && this.gameData.curPeriod <= egret.Def.PERIOD_BaiE_Final) {
                return this._runningDelay * this._runningSpeed * 2;
            }
            else {
                return this._runningDelay * this._runningSpeed;
            }
        };
        __egretProto__.getRunningRate = function () {
            return (this._runningDelay / 1000) * this._runningSpeed;
        };
        __egretProto__.getCommonValue1 = function (type) {
            if (type === void 0) { type = 0; }
            var info = egret.SheetUtil.getCommonInfo(type);
            return info.value1;
        };
        __egretProto__.getModeDiffInfo = function (mode, diff) {
            egret.SheetUtil.initModeDiffInfo();
            for (var i = 0; i < egret.SheetUtil.arrModeDiffInfo.length; ++i) {
                var modeDiffInfo = egret.SheetUtil.arrModeDiffInfo[i];
                if (modeDiffInfo.modeDiff == egret.Def.getModeDiffStr(mode, diff)) {
                    return modeDiffInfo;
                }
            }
            return null;
        };
        __egretProto__.getEvolutionInfoBySpeciesID = function (speciesID) {
            egret.SheetUtil.initEvolutionInfo();
            for (var i = 0; i < egret.SheetUtil.arrEvolutionInfo.length; ++i) {
                var evolutionInfo = egret.SheetUtil.arrEvolutionInfo[i];
                if (evolutionInfo.speciesID == speciesID)
                    return evolutionInfo;
            }
            return null;
        };
        __egretProto__.getFixTipsInfos = function (type) {
            var infos = [];
            for (var i = 0; i < this._allFixTips.length; ++i) {
                var info = this._allFixTips[i];
                if (info.type == type) {
                    infos.push(info);
                }
            }
            return infos;
        };
        __egretProto__.executeFixTips = function (fixTipsInfo) {
            if (!fixTipsInfo || this.excutingFixTips)
                return;
            var index = this._allFixTips.indexOf(fixTipsInfo);
            if (index == -1)
                return;
            if (fixTipsInfo.modeAndDiff[0] != "0" && fixTipsInfo.modeAndDiff.indexOf(egret.Def.getModeDiffStr(this.gameData.mode, this.gameData.difficulty)) == -1) {
                return; //判断模式和难度
            }
            this.isPause = true;
            this.excutingFixTips = true;
            this._allFixTips.splice(index, 1);
            this.dispatchEvent(new egret.CusEvent(egret.GameEventType.FIX_TIPS_EXECUTE, fixTipsInfo));
        };
        __egretProto__.getTalent = function (tabID) {
            if (tabID === void 0) { tabID = 0; }
            if (this._talentDic)
                return this._talentDic[tabID];
            return null;
        };
        __egretProto__.getTalentByPicIndex = function (picIndex) {
            if (picIndex === void 0) { picIndex = 0; }
            var length = this._talentDic.length;
            for (var i = 0; i < length; i++) {
                var talent = this._talentDic[i];
                if (talent.info.picIndex == picIndex) {
                    return talent;
                }
            }
            return null;
        };
        __egretProto__.getTalentBySkillID = function (skillID) {
            var length = this._talentDic.length;
            for (var i = 0; i < length; i++) {
                var talent = this._talentDic[i];
                if (talent && talent.info.skillID == skillID) {
                    return talent;
                }
            }
            return null;
        };
        __egretProto__.setTalentUnlockLocal = function (id, value) {
            egret.localStorage.setItem("talent" + id, value.toString());
            var talent = this.getTalent(id);
            if (talent)
                talent.isUnlock = value;
            this.dispatchEvent(new egret.CusEvent(egret.GameEventType.UNLOCK_TALENT));
        };
        __egretProto__.getTalentUnlockLocal = function (id) {
            return egret.localStorage.getItem("talent" + id) == "true";
        };
        __egretProto__.setShopBuyID = function (id, value) {
            egret.localStorage.setItem("shop" + id, value.toString());
            this.dispatchEvent(new egret.CusEvent(egret.GameEventType.SHOP_BUY));
        };
        __egretProto__.getShopIsBuy = function (id) {
            return egret.localStorage.getItem("shop" + id) == "true";
        };
        __egretProto__.getShopFight = function () {
            var shopInfo = egret.SheetUtil.getShopInfo(1);
            if (this.getShopIsBuy(shopInfo.tabID)) {
                return shopInfo.effectValue;
            }
            return 0;
        };
        __egretProto__.getShopLive = function () {
            var shopInfo = egret.SheetUtil.getShopInfo(2);
            if (this.getShopIsBuy(shopInfo.tabID)) {
                return shopInfo.effectValue;
            }
            return 0;
        };
        __egretProto__.getShopSocial = function () {
            var shopInfo = egret.SheetUtil.getShopInfo(3);
            if (this.getShopIsBuy(shopInfo.tabID)) {
                return shopInfo.effectValue;
            }
            return 0;
        };
        __egretProto__.getOverDefence = function () {
            var shopInfo = egret.SheetUtil.getShopInfo(4);
            if (this.getShopIsBuy(shopInfo.tabID)) {
                return shopInfo.effectValue;
            }
            return 0;
        };
        __egretProto__.getShopReduceDNA = function () {
            var shopInfo = egret.SheetUtil.getShopInfo(12);
            if (this.getShopIsBuy(shopInfo.tabID)) {
                return shopInfo.effectValue;
            }
            return 0;
        };
        __egretProto__.getShopAutoCollectBub = function () {
            return this.getShopIsBuy(5);
        };
        __egretProto__.getShopCustomProperty = function () {
            return this.getShopIsBuy(6);
        };
        __egretProto__.recheckTalentVisible = function (forTalent) {
            var length1 = this._talentDic.length;
            for (var i1 = 0; i1 < length1; i1++) {
                var talent = this._talentDic[i1];
                if (!talent)
                    continue;
                if (!forTalent || talent.info.type == forTalent.info.type) {
                    if (!talent.isVisible) {
                        var canVisible = true;
                        var prevTalent;
                        for (var i = 0; i < talent.info.prevID.length; ++i) {
                            prevTalent = this.getTalent(talent.info.prevID[i]);
                            if (!prevTalent.isActive) {
                                canVisible = false;
                                break;
                            }
                        }
                        talent.isVisible = canVisible;
                    }
                }
            }
            if (forTalent)
                this.processTalent(forTalent);
        };
        __egretProto__.processTalent = function (talent) {
            this.processTalentEffect(talent.info.effect1, talent.info.effectValue1);
            this.processTalentEffect(talent.info.effect2, talent.info.effectValue2);
            this.dispatchEvent(new egret.CusEvent(egret.GameEventType.TALENT_ADD, talent));
        };
        __egretProto__.processTalentEffect = function (type, value) {
            switch (type) {
                case 1:
                    this.talentEffect.breedRate += value;
                    break;
                case 2:
                    if (value > 1) {
                        this.talentEffect.live += value;
                    }
                    else {
                        this.talentEffect.liveRate += value;
                    }
                    break;
                case 3:
                    if (value > 1) {
                        this.talentEffect.social += value;
                    }
                    else {
                        this.talentEffect.socialRate += value;
                    }
                    break;
                case 4:
                    this.talentEffect.sun += value;
                    break;
                case 5:
                    this.talentEffect.temp += value;
                    break;
                case 6:
                    this.talentEffect.O2 += value;
                    break;
                case 7:
                    this.talentEffect.AQI += value;
                    break;
                case 8:
                    this.talentEffect.water += value;
                    break;
                case 9:
                    this.talentEffect.plant += value;
                    break;
                case 10:
                    this.talentEffect.meat += value;
                    break;
                case 11:
                    if (value > 1) {
                        this.talentEffect.fight += value;
                    }
                    else {
                        this.talentEffect.fightRate += value;
                    }
                    break;
                case 12:
                    this.talentEffect.hideRate += value;
                    break;
                case 13:
                    break;
                default:
                    break;
            }
        };
        __egretProto__.triggerRandomEventNoEffect = function () {
            var events = [];
            var ranEventInfo;
            var randomEvent;
            egret.SheetUtil.initRanEventInfo();
            for (var i = 0; i < egret.SheetUtil.arrRanEventInfo.length; ++i) {
                ranEventInfo = egret.SheetUtil.arrRanEventInfo[i];
                if (!egret.Def.isNoEffectEvent(ranEventInfo)) {
                    continue;
                }
                if (ranEventInfo.periods.indexOf(this.gameData.curPeriod) == -1) {
                    continue;
                }
                if (this._lmtCountEventIDs.indexOf(ranEventInfo.tabID) != -1) {
                    continue;
                }
                if (Math.random() < ranEventInfo.rate) {
                    events.push(ranEventInfo);
                }
            }
            if (events.length == 0) {
                this.triggerRandomEventNoEffect();
            }
            else {
                ranEventInfo = events[(Math.random() * events.length) >> 0];
                randomEvent = new egret.RandomEvent(ranEventInfo);
                this.gameData.news.push(randomEvent);
                if (ranEventInfo.lmtCount != 0) {
                    this._lmtCountEventIDs.push(ranEventInfo.tabID);
                }
                this.dispatchEvent(new egret.CusEvent(egret.GameEventType.TRIGGER_RANDOM_EVENT, randomEvent));
            }
        };
        __egretProto__.triggerRandomEventOverState = function () {
            var ranEventInfo;
            var events = [];
            var autoEvents = [];
            egret.SheetUtil.initRanEventInfo();
            for (var i = 0; i < egret.SheetUtil.arrRanEventInfo.length; ++i) {
                ranEventInfo = egret.SheetUtil.arrRanEventInfo[i];
                if (!egret.Def.isOverStateEvent(ranEventInfo)) {
                    continue;
                }
                if (ranEventInfo.periods.indexOf(this.gameData.curPeriod) == -1) {
                    continue;
                }
                if (this._lmtCountEventIDs.indexOf(ranEventInfo.tabID) != -1) {
                    continue;
                }
                var isConflict = false; //冲突判断
                for (var k = 0; k < this._lmtCountEventIDs.length; ++k) {
                    var checkInfo = egret.SheetUtil.getRanEventInfo(this._lmtCountEventIDs[k]);
                    if (checkInfo.conflictID != 0 && checkInfo.conflictID == ranEventInfo.conflictID) {
                        isConflict = true;
                        break;
                    }
                }
                if (isConflict) {
                    continue;
                }
                if (egret.Def.isOverStateAutoEvent(ranEventInfo)) {
                    if (Math.random() < ranEventInfo.rate) {
                        autoEvents.push(ranEventInfo);
                    }
                }
                else {
                    if (Math.random() < ranEventInfo.rate) {
                        events.push(ranEventInfo);
                    }
                }
            }
            if (events.length > 0) {
                ranEventInfo = events[(Math.random() * events.length) >> 0];
                this.dispatchEvent(new egret.CusEvent(egret.GameEventType.TRIGGER_RANDOM_EVENT, new egret.RandomEvent(ranEventInfo)));
            }
            if (autoEvents.length > 0) {
                ranEventInfo = autoEvents[(Math.random() * autoEvents.length) >> 0];
                this.excuteRandomEventEffect(null, ranEventInfo.effect1, ranEventInfo.effectValue1);
                this.excuteRandomEventEffect(null, ranEventInfo.effect2, ranEventInfo.effectValue2);
                this.dispatchEvent(new egret.CusEvent(egret.GameEventType.TRIGGER_RANDOM_EVENT, new egret.RandomEvent(ranEventInfo)));
            }
        };
        __egretProto__.triggerRandomEventEffect = function () {
            var ranEventInfo;
            var hasEvent = false;
            egret.SheetUtil.initRanEventInfo();
            for (var i = 0; i < egret.SheetUtil.arrRanEventInfo.length; ++i) {
                ranEventInfo = egret.SheetUtil.arrRanEventInfo[i];
                if (!egret.Def.isHasEffectEvent(ranEventInfo)) {
                    continue;
                }
                if (ranEventInfo.periods.indexOf(this.gameData.curPeriod) == -1) {
                    continue;
                }
                if (this._lmtCountEventIDs.indexOf(ranEventInfo.tabID) != -1) {
                    continue;
                }
                if (ranEventInfo.modeAndDiff[0] != "0" && ranEventInfo.modeAndDiff.indexOf(egret.Def.getModeDiffStr(this.gameData.mode, this.gameData.difficulty)) == -1) {
                    continue;
                }
                var isConflict = false; //冲突判断
                for (var k = 0; k < this._lmtCountEventIDs.length; ++k) {
                    var checkInfo = egret.SheetUtil.getRanEventInfo(this._lmtCountEventIDs[k]);
                    if (checkInfo.conflictID != 0 && checkInfo.conflictID == ranEventInfo.conflictID) {
                        isConflict = true;
                        break;
                    }
                }
                if (isConflict) {
                    continue;
                }
                hasEvent = true;
                if (Math.random() < ranEventInfo.rate) {
                    this._curRandEvents.push(ranEventInfo);
                }
            }
            if (this._curRandEvents.length == 0) {
                if (hasEvent) {
                    this.triggerRandomEventEffect();
                }
            }
            else if (this._curRandEvents.length > 3) {
                while (this._curRandEvents.length > 3) {
                    this._curRandEvents.splice((Math.random() * this._curRandEvents.length) >> 0, 1);
                }
            }
            this._executeRandEventTime = 0;
        };
        __egretProto__.executeRandomEvent = function (randomEvent) {
            var effectAreas;
            var info = randomEvent.info;
            if (info.effect1 == 8) {
                var checkAreas = [];
                for (var i = 0; i < this._gameData.areas.length; ++i) {
                    var area = this._gameData.areas[i];
                    if (area.cusSpeciesCount > 0) {
                        checkAreas.push(area);
                    }
                }
                if (checkAreas.length > 0) {
                    area = checkAreas[(Math.random() * checkAreas.length) >> 0];
                    randomEvent.areaIdx = randomEvent.info.areaIDs.indexOf(area.info.tabID);
                }
            }
            if (info.effectArea == egret.Def.BIG_AREA_CUR_AREA) {
                effectAreas = [];
                effectAreas.push(this._gameData.getArea(randomEvent.areaID));
            }
            else if (info.effectArea == egret.Def.BIG_AREA_CUR_PLATE) {
                effectAreas = this._gameData.getAreaByPlant(egret.SheetUtil.getAreaInfo(randomEvent.areaID).plateID);
            }
            else if (info.effectArea == egret.Def.BIG_AREA_ALL_AREA) {
                effectAreas = this._gameData.getAllArea().concat();
            }
            else if (info.effectArea == egret.Def.BIG_AREA_ALL_SEA) {
                effectAreas = this._gameData.getAreaByType(egret.Def.LIVE_TYPE_SEA);
            }
            else if (info.effectArea == egret.Def.BIG_AREA_ALL_LAND) {
                effectAreas = this._gameData.getAreaByType(egret.Def.LIVE_TYPE_LAND);
            }
            var length = effectAreas.length;
            for (var i = 0; i < length; i++) {
                var area = effectAreas[i];
                this.excuteRandomEventEffect(area, info.effect1, info.effectValue1);
                this.excuteRandomEventEffect(area, info.effect2, info.effectValue2);
            }
            this.isPause = true;
            if (info.lmtCount != 0) {
                this._lmtCountEventIDs.push(info.tabID);
            }
            this.dispatchEvent(new egret.CusEvent(egret.GameEventType.TRIGGER_RANDOM_EVENT, randomEvent));
        };
        __egretProto__.excuteRandomEventEffect = function (area, effectType, effectValue) {
            if (effectType == 1) {
                area.condition.sun += effectValue;
            }
            else if (effectType == 2) {
                area.condition.temperature += effectValue;
            }
            else if (effectType == 3) {
                area.condition.O2 += effectValue;
            }
            else if (effectType == 4) {
                area.condition.AQI += effectValue;
            }
            else if (effectType == 5) {
                area.condition.water += effectValue;
            }
            else if (effectType == 6) {
                area.condition.plant += effectValue;
            }
            else if (effectType == 7) {
                area.condition.meat += effectValue;
            }
            else if (effectType == 8) {
                //遭遇物种
                var fightUnit = new egret.FightUnit();
                fightUnit.setData(area, egret.SheetUtil.getSpeciesInfo((effectValue) >> 0));
                this._fightUnits.push(fightUnit);
            }
            else if (effectType == 9) {
            }
            else if (effectType == 10) {
                this._gameData.cusSpecies.breedRate += effectValue;
                if (this._gameData.cusSpecies.breedRate < 0)
                    this.gameData.cusSpecies.breedRate = 0;
            }
            else if (effectType == 11) {
                this._gameData.DNARate += effectValue;
            }
            else if (effectType == 12) {
                this._gameData.cusSpecies.live += effectValue;
                if (this._gameData.cusSpecies.live < 0)
                    this.gameData.cusSpecies.live = 0;
            }
            else if (effectType == 13) {
                this._gameData.cusSpecies.social += effectValue;
                if (this._gameData.cusSpecies.social < 0)
                    this.gameData.cusSpecies.social = 0;
            }
            else if (effectType == 14) {
                if (effectValue >= 1) {
                    area.cusSpeciesCount -= effectValue;
                }
                else {
                    area.cusSpeciesCount -= area.cusSpeciesCount * effectValue;
                }
            }
            else if (effectType == 15) {
                this.gameData.killCusSpecies(effectValue);
            }
            else if (effectType == 16) {
                this.gameData.cusSpecies.fight += effectValue;
                if (this.gameData.cusSpecies.fight < 0)
                    this.gameData.cusSpecies.fight = 0;
            }
            else if (effectType == 17) {
                this.gameData.overFightUnit.species.fight += effectValue; //此处不能做<0判断
            }
            else if (effectType == 18) {
                this.gameData.overFightUnit.species.count += effectValue;
            }
        };
        return SysGame;
    })(egret.EventDispatcher);
    egret.SysGame = SysGame;
    SysGame.prototype.__class__ = "egret.SysGame";
})(egret || (egret = {}));
