var egret;
(function (egret) {
    var StringUtil = (function () {
        function StringUtil() {
        }
        var __egretProto__ = StringUtil.prototype;
        /**
         * 将content中符合reg的内容都用replacer替换
         */
        StringUtil.replaceStr = function (content, reg, replacer) {
            var myPattern = new RegExp(reg, "g");
            return content.replace(myPattern, replacer);
        };
        /**
         * 使用传入的各个参数替换指定的字符串内的“{n}”标记
         * N为索引，从0记起
         * */
        StringUtil.substitute = function (str) {
            var rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                rest[_i - 1] = arguments[_i];
            }
            if (str == null)
                return '';
            var len = rest.length;
            var args;
            if (len == 1 && rest[0] instanceof Array) {
                args = (rest[0]);
                len = args.length;
            }
            else {
                args = rest;
            }
            for (var i = 0; i < len; i++) {
                str = str.replace(new RegExp("\\{" + i + "\\}", "g"), args[i]);
            }
            return str;
        };
        /**
        * Counts the occurrences of needle in haystack. <br />
        * {@code trace (StringUtils.count ('hello world!', 'o')); // 2
        * }
        * @param haystack :String
        * @param needle :String
        * @param offset :Number (optional)
        * @param length :Number (optional)
        * @return The number of times the needle substring occurs in the
        * haystack string. Please note that needle is case sensitive.
        */
        StringUtil.count = function (haystack, needle, offset, length) {
            if (offset === void 0) { offset = 0; }
            if (length === void 0) { length = 0; }
            if (length === 0)
                length = haystack.length;
            var result = 0;
            haystack = haystack.slice(offset, length);
            while (haystack.length > 0 && haystack.indexOf(needle) != -1) {
                haystack = haystack.slice((haystack.indexOf(needle) + needle.length));
                result++;
            }
            return result;
        };
        /**
         * Strip whitespace and newline (or other) from the beginning and end of a string. <br />
         * {@code trace (StringUtils.trim ('hello world! ')); // hello world!
         * }
         * @param str :String
         * @param charList :Array (optional)
         * @return A string with whitespace stripped from the beginning and end
         * of str. Without the second parameter, trim() will strip characters that
         * defined in WHITESPACE_TOKENS and NEWLINE_TOKENS array.
         */
        StringUtil.trim = function (str, charList) {
            if (charList === void 0) { charList = null; }
            var list;
            if (charList) {
                list = charList;
            }
            else {
                list = StringUtil.WHITESPACE_TOKENS.concat(StringUtil.NEWLINE_TOKENS);
            }
            str = StringUtil.trimLeft(str.toString(), list);
            str = StringUtil.trimRight(str.toString(), list);
            return str;
        };
        /**
         * Does the same how trim method, but only on left-side. <br />
         * {@code trace (StringUtils.trimLeft ('hello world!')); // hello world!
         * }
         * @param str :String
         * @param charList :Array (optional)
         * @return A string with whitespace stripped from the start of str.
         * Without the second parameter, trimLeft() will strip haracters of
         * WHITESPACE_TOKENS + NEWLINE_TOKENS.
         */
        StringUtil.trimLeft = function (str, charList) {
            if (charList === void 0) { charList = null; }
            var list;
            if (charList)
                list = charList;
            else
                list = StringUtil.WHITESPACE_TOKENS.concat(StringUtil.NEWLINE_TOKENS);
            while (list.indexOf(str.substr(0, 1)) > -1 && str.length > 0) {
                str = str.substr(1);
            }
            return str;
        };
        /**
         * Does the same how trim method, but only on right-side. <br />
         * {@code trace (StringUtils.trimRight ('hello world!')); // hello world!
         * }
         * @param str :String
         * @param charList :Array (optional)
         * @return A string with whitespace stripped from the end of str.
         * Without the second parameter, trimRight() will strip haracters of
         * WHITESPACE_TOKENS + NEWLINE_TOKENS.
         */
        StringUtil.trimRight = function (str, charList) {
            if (charList === void 0) { charList = null; }
            var list;
            if (charList)
                list = charList;
            else
                list = StringUtil.WHITESPACE_TOKENS.concat(StringUtil.NEWLINE_TOKENS);
            while (list.indexOf(str.substr(str.length - 1)) > -1 && str.length > 0) {
                str = str.substr(0, str.length - 1);
            }
            return str;
        };
        StringUtil.getByteLength = function (str) {
            if (!str || str == "")
                return 0;
            var ba = new egret.ByteArray();
            ba.endian = egret.Endian.LITTLE_ENDIAN;
            //ba.writeMultiByte(str,"gb2312");
            return ba.length;
        };
        StringUtil.NEWLINE_TOKENS = new Array('\n', '\r');
        StringUtil.WHITESPACE_TOKENS = new Array(' ', '\t');
        return StringUtil;
    })();
    egret.StringUtil = StringUtil;
    StringUtil.prototype.__class__ = "egret.StringUtil";
})(egret || (egret = {}));
