var egret;
(function (egret) {
    var AreaView = (function (_super) {
        __extends(AreaView, _super);
        function AreaView() {
            _super.call(this);
            this.white = new egret.gui.UIAsset();
            //this.speciesCon = new egret.gui.Group();
            egret.SysGame.getInstance().addEventListener(egret.GameEventType.GAME_RUNNING, this.onGameRuning, this);
            egret.SysGame.getInstance().gameData.cusSpecies.addEventListener(egret.GameEventType.SPECIES_INFO_CHANGE, this.onSpeciesInfoChange, this);
            this.pointIndexs = [];
            this.removePointIndexs = [];
        }
        var __egretProto__ = AreaView.prototype;
        __egretProto__.destroy = function () {
            egret.Tween.removeTweens(this.white);
            egret.SysGame.getInstance().removeEventListener(egret.GameEventType.GAME_RUNNING, this.onGameRuning, this);
            egret.SysGame.getInstance().gameData.cusSpecies.removeEventListener(egret.GameEventType.SPECIES_INFO_CHANGE, this.onSpeciesInfoChange, this);
            this.area.removeEventListener(egret.GameEventType.SPECIES_MoveTo_Area, this.onSpeciesMoveToArea, this);
            if (this._fightUnit) {
                this._fightUnit.removeEventListener(egret.GameEventType.FIGHT_UNIT_INIT, this.onFightInit, this);
                this._fightUnit.removeEventListener(egret.GameEventType.FIGHT_OVER_CHANGE, this.onFightOver, this);
            }
        };
        Object.defineProperty(__egretProto__, "area", {
            get: function () {
                return this._area;
            },
            set: function (value) {
                this._area = value;
                this.pointIndexs.length = 0;
                this.removePointIndexs.length = 0;
                this.area.addEventListener(egret.GameEventType.SPECIES_MoveTo_Area, this.onSpeciesMoveToArea, this);
                this.area.addEventListener(egret.GameEventType.AREA_FIGHT_CHANGE, this.onAreaFightChange, this);
                for (var i = 0; i < this._area.info.points.length; i++) {
                    this.pointIndexs.push(i);
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "bgWidth", {
            get: function () {
                return this.bg.width;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "bgHeight", {
            get: function () {
                return this.bg.height;
            },
            enumerable: true,
            configurable: true
        });
        __egretProto__.setBg = function (value) {
            this.bg = value;
            this.x = this.bg.x;
            this.y = this.bg.y;
            this.bg.x = this.bg.y = 0;
            this.addElement(this.bg);
            //if (this.area.info.type == Def.LIVE_TYPE_LAND) {
            //this.landSpeciesGroup.addElement(this.speciesCon);
            //} else {
            //this.addElement(this.speciesCon);
            //}
        };
        Object.defineProperty(__egretProto__, "selected", {
            set: function (value) {
                if (value) {
                    this.white.source = this.bg.source + "_W";
                    this.addElement(this.white);
                    //if (this.area.info.type != Def.LIVE_TYPE_LAND) {
                    //    this.addElement(this.speciesCon);
                    //}
                    var tw = egret.Tween.get(this.white, { loop: true });
                    this.white.alpha = 0.5;
                    tw.to({ alpha: 0.2 }, 2000).to({ alpha: 0.5 }, 2000);
                }
                else {
                    egret.Tween.removeTweens(this.white);
                    if (this.white.owner)
                        this.white.owner.removeElement(this.white);
                }
            },
            enumerable: true,
            configurable: true
        });
        __egretProto__.onGameRuning = function (event) {
            if (event === void 0) { event = null; }
            var count = 0;
            if (this.area.cusSpeciesCountShow == 0) {
                count = 0;
            }
            else {
                var viewCountPer = egret.SysGame.getInstance().getCommonValue1(egret.CommonInfoType.viewCountPer);
                count = this.area.cusSpeciesCountShow / viewCountPer;
                count = (count >> 0) + 1;
            }
            var speciesView;
            if (!egret.SysGame.getInstance().gameData.overState) {
                while (this.speciesCon.numElements < count) {
                    speciesView = new egret.AreaSpeciesView();
                    speciesView.info = egret.SysGame.getInstance().gameData.cusSpecies.info;
                    var ran = (Math.random() * this.pointIndexs.length) >> 0;
                    var index = this.pointIndexs.splice(ran, 1)[0];
                    var pointStr = this.area.info.points[index];
                    var px = parseFloat(pointStr.split("_")[0]);
                    var py = parseFloat(pointStr.split("_")[1]);
                    this.removePointIndexs.push(index);
                    speciesView.x = px;
                    speciesView.y = py;
                    speciesView.rotation = -this.rotation;
                    this.speciesCon.addElement(speciesView);
                }
                while (this.speciesCon.numElements > count) {
                    this.speciesCon.removeElementAt(0);
                    this.pointIndexs.push(this.removePointIndexs.shift());
                }
            }
            else {
                for (var i = 0; i < this.speciesCon.numElements; ++i) {
                    speciesView = this.speciesCon.getElementAt(i);
                    if (!speciesView.isDie && i < this.speciesCon.numElements - count) {
                        speciesView.isDie = true;
                    }
                }
            }
        };
        __egretProto__.onSpeciesInfoChange = function (event) {
            if (event === void 0) { event = null; }
            for (var i = 0; i < this.speciesCon.numElements; ++i) {
                var speciesView = this.speciesCon.getElementAt(i);
                speciesView.info = egret.SysGame.getInstance().gameData.cusSpecies.info;
            }
        };
        __egretProto__.onAreaFightChange = function (event) {
            if (event === void 0) { event = null; }
            if (this._fightUnit) {
                this._fightUnit.removeEventListener(egret.GameEventType.FIGHT_UNIT_INIT, this.onFightInit, this);
                this._fightUnit.removeEventListener(egret.GameEventType.FIGHT_OVER_CHANGE, this.onFightOver, this);
            }
            this._fightUnit = this.area.fightUnit;
            if (this._fightUnit) {
                this._fightUnit.addEventListener(egret.GameEventType.FIGHT_UNIT_INIT, this.onFightInit, this);
                this._fightUnit.addEventListener(egret.GameEventType.FIGHT_OVER_CHANGE, this.onFightOver, this);
            }
        };
        __egretProto__.addDNABubble = function (num) {
            var bv;
            bv = new egret.BubbleView();
            bv.addDNA = num;
            this.setBvPostion(bv, this.area.info.pixels);
            bv.rotation = -this.rotation;
            this.bvCon.addElement(bv);
        };
        __egretProto__.onSpeciesMoveToArea = function (event) {
            if (event === void 0) { event = null; }
            var bv;
            bv = new egret.BubbleView();
            bv.moveDNA = egret.SysGame.getInstance().getCommonValue1(egret.CommonInfoType.GetDNAWhenMoveToArea);
            this.setBvPostion(bv, this.area.info.pixels);
            bv.rotation = -this.rotation;
            this.bvCon.addElement(bv);
            var isPlateFirstMove = true;
            for (var i = 0; i < egret.SysGame.getInstance().gameData.areas.length; ++i) {
                var checkArea = egret.SysGame.getInstance().gameData.areas[i];
                if (checkArea == this.area)
                    continue;
                if (checkArea.info.plateID == this.area.info.plateID && checkArea.cusSpeciesCount > 0) {
                    isPlateFirstMove = false;
                    break;
                }
            }
            if (isPlateFirstMove) {
                bv = new egret.BubbleView();
                bv.moveDNA = egret.SysGame.getInstance().getCommonValue1(egret.CommonInfoType.GetDNAWhenMoveToPlate);
                this.setBvPostion(bv, this.area.info.pixels);
                bv.rotation = -this.rotation;
                this.bvCon.addElement(bv);
            }
        };
        __egretProto__.setBvPostion = function (bv, pixels) {
            var bw = 66;
            var bh = 66;
            var indexs = pixels.concat();
            var rect1 = new egret.Rectangle(0 + bw / 2, 62 + bh, 960 - 237 - bw / 2, 350 - bh);
            var rect2 = new egret.Rectangle(137 + bw / 2, 397, 960 - 237 - 137 - bw / 2, 70);
            var point = new egret.Point();
            while (indexs.length) {
                var ran = (Math.random() * indexs.length) >> 0;
                var index = indexs[ran];
                var px = index % this.bgWidth;
                var py = index / this.bgWidth;
                point.x = px + this.x;
                point.y = py + this.y;
                if (rect1.containsPoint(point) || rect2.containsPoint(point)) {
                    bv.x = px;
                    bv.y = py;
                    break;
                }
                else {
                    indexs.splice(ran, 1);
                }
            }
        };
        __egretProto__.onFightInit = function (event) {
            if (this._fightUnit) {
                var speciesView;
                for (var i = 0; i < this.speciesCon.numElements; ++i) {
                    speciesView = this.speciesCon.getElementAt(i);
                    if (!speciesView.isDie) {
                        speciesView.onFight(false);
                    }
                }
            }
        };
        __egretProto__.onFightOver = function (event) {
            if (this._fightUnit.isOver) {
                var speciesView;
                for (var i = 0; i < this.speciesCon.numElements; ++i) {
                    speciesView = this.speciesCon.getElementAt(i);
                    if (!speciesView.isDie) {
                        speciesView.onFight(true);
                    }
                }
            }
        };
        return AreaView;
    })(egret.gui.Group);
    egret.AreaView = AreaView;
    AreaView.prototype.__class__ = "egret.AreaView";
})(egret || (egret = {}));
