var egret;
(function (egret) {
    var CollectSceneUI = (function (_super) {
        __extends(CollectSceneUI, _super);
        function CollectSceneUI(sceneID) {
            _super.call(this, sceneID);
            this._gameData = egret.SysGame.getInstance().gameData;
            this.skinName = skins.startScene.CollectViewSkin;
        }
        var __egretProto__ = CollectSceneUI.prototype;
        __egretProto__.destroy = function () {
            _super.prototype.destroy.call(this);
        };
        __egretProto__.enterScene = function () {
            _super.prototype.enterScene.call(this);
            if (this.btnClose) {
                this.update();
            }
        };
        __egretProto__.createChildren = function () {
            _super.prototype.createChildren.call(this);
            this.update();
            this.btnClose.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onCloseTap, this);
        };
        __egretProto__.update = function () {
            var str = egret.localStorage.getItem("collect_active");
            if (str && str != "") {
                var ids = str.split("|");
                for (var i = 0; i < ids.length; ++i) {
                    var id = parseInt(ids[i]);
                    var specieInfo = egret.SheetUtil.getSpeciesInfo(id);
                    var uiAsset = this.skin["Dinosaur_" + id];
                    if (uiAsset) {
                        uiAsset.name = id.toString();
                        uiAsset.source = specieInfo.collectPic;
                        uiAsset.removeEventListener(egret.TouchEvent.TOUCH_BEGIN, this.onPicTapBegin, this);
                        uiAsset.addEventListener(egret.TouchEvent.TOUCH_BEGIN, this.onPicTapBegin, this);
                        uiAsset.removeEventListener(egret.TouchEvent.TOUCH_TAP, this.onPicTap, this);
                        uiAsset.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onPicTap, this);
                    }
                }
            }
        };
        __egretProto__.onPicTap = function (event) {
            var uiAsset = event.currentTarget;
            if (!this.sdv) {
                this.sdv = new egret.SpeciesDetailView();
            }
            this.sdv.horizontalCenter = 0;
            this.sdv.verticalCenter = 5;
            var speciesInfo = egret.SheetUtil.getSpeciesInfo(parseInt(uiAsset.name));
            this.sdv.setInfo(speciesInfo);
            this.skin.addElement(this.sdv);
        };
        __egretProto__.onPicTapBegin = function (event) {
            this.curTapPic = event.currentTarget;
            if (this.curTapPic.scaleX != 1)
                return;
            var w = this.curTapPic.width;
            var h = this.curTapPic.height;
            this.curTapPic.scaleX = this.curTapPic.scaleY = 0.95;
            this.curTapPic.x += w * 0.05 / 2;
            this.curTapPic.y += h * 0.05 / 2;
            this.stage.addEventListener(egret.TouchEvent.TOUCH_END, this.onStageTouchEnd, this);
            this.stage.addEventListener(egret.TouchEvent.TOUCH_OUT, this.onStageTouchEnd, this);
        };
        __egretProto__.onStageTouchEnd = function (event) {
            this.stage.removeEventListener(egret.TouchEvent.TOUCH_END, this.onStageTouchEnd, this);
            this.stage.removeEventListener(egret.TouchEvent.TOUCH_OUT, this.onStageTouchEnd, this);
            this.curTapPic.scaleX = this.curTapPic.scaleY = 1;
            this.curTapPic.x -= this.curTapPic.width * 0.05 / 2;
            this.curTapPic.y -= this.curTapPic.height * 0.05 / 2;
        };
        __egretProto__.onCloseTap = function (event) {
            egret.SceneUIUtil.runLastScene();
            if (this.sdv && this.sdv.owner) {
                this.sdv.owner.removeElement(this.sdv);
            }
        };
        return CollectSceneUI;
    })(BaseSceneUI);
    egret.CollectSceneUI = CollectSceneUI;
    CollectSceneUI.prototype.__class__ = "egret.CollectSceneUI";
})(egret || (egret = {}));
