var egret;
(function (egret) {
    var RanEventView = (function (_super) {
        __extends(RanEventView, _super);
        function RanEventView() {
            _super.call(this);
            this.skinName = skins.mainScene.RandomEventSkin;
            this.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onMouseClick, this);
        }
        var __egretProto__ = RanEventView.prototype;
        Object.defineProperty(__egretProto__, "fixInfo", {
            get: function () {
                return this._fixInfo;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(__egretProto__, "skillInfo", {
            get: function () {
                return this._skillInfo;
            },
            enumerable: true,
            configurable: true
        });
        __egretProto__.createChildren = function () {
            _super.prototype.createChildren.call(this);
            egret.LanguageUtil.setLableLanguage(this.tfTitle, "random_1");
            egret.LanguageUtil.setLableLanguage(this.tfContent, "random_2");
            this.update();
        };
        __egretProto__.setRandomEvent = function (randomEvent) {
            if (this._fixInfo)
                return;
            this._randomEvent = randomEvent;
            this._fixInfo = null;
            egret.SysGame.getInstance().excutingFixTips = false;
            this._skillInfo = null;
            this.update();
        };
        __egretProto__.setFixInfo = function (info) {
            this._fixInfo = info;
            this._randomEvent = null;
            this._skillInfo = null;
            this.update();
        };
        __egretProto__.setSkillInfo = function (info, isActive, enemyName) {
            if (enemyName === void 0) { enemyName = ""; }
            if (this._fixInfo)
                return;
            this._fixInfo = null;
            egret.SysGame.getInstance().excutingFixTips = false;
            this._randomEvent = null;
            this._skillInfo = info;
            this._isActive = isActive;
            this.enemyName = enemyName;
            this.update();
        };
        __egretProto__.update = function () {
            var title;
            var content;
            if (!this.tfTitle) {
                return;
            }
            this.pic.source = null;
            if (this._randomEvent) {
                this.tfTitle.text = egret.LanguageUtil.getLanguage(this._randomEvent.info.title);
                this.tfContent.text = this._randomEvent.eventDesc;
                if (this._randomEvent.info.pic != "0") {
                    this.pic.source = this._randomEvent.info.pic;
                }
                else {
                    this.pic.source = "Event_Risk";
                }
            }
            else if (this._fixInfo) {
                title = egret.LanguageUtil.getLanguage(this._fixInfo.title);
                content = egret.LanguageUtil.getLanguage(this._fixInfo.desc);
                title = title.replace(new RegExp("%name", "g"), egret.LanguageUtil.getLanguage(egret.SysGame.getInstance().gameData.cusSpecies.info.name));
                if (egret.SysGame.getInstance().startArea) {
                    title = title.replace(new RegExp("%Sarea", "g"), egret.LanguageUtil.getLanguage(egret.SysGame.getInstance().startArea.info.name));
                }
                if (egret.SysGame.getInstance().moveArea) {
                    title = title.replace(new RegExp("%Marea", "g"), egret.LanguageUtil.getLanguage(egret.SysGame.getInstance().moveArea.info.name));
                }
                content = content.replace(new RegExp("%name", "g"), egret.LanguageUtil.getLanguage(egret.SysGame.getInstance().gameData.cusSpecies.info.name));
                if (egret.SysGame.getInstance().startArea) {
                    content = content.replace(new RegExp("%Sarea", "g"), egret.LanguageUtil.getLanguage(egret.SysGame.getInstance().startArea.info.name));
                }
                if (egret.SysGame.getInstance().moveArea) {
                    content = content.replace(new RegExp("%Marea", "g"), egret.LanguageUtil.getLanguage(egret.SysGame.getInstance().moveArea.info.name));
                }
                this.tfTitle.text = title;
                this.tfContent.text = content;
                if (this._fixInfo.pic != "0") {
                    this.pic.source = this._fixInfo.pic;
                }
                else {
                    this.pic.source = "Event_Risk";
                }
            }
            else if (this._skillInfo) {
                if (this._isActive) {
                    title = egret.LanguageUtil.getLanguage("talent_get_title");
                    content = egret.LanguageUtil.getLanguage(this._skillInfo.activeDesc).replace("%player", egret.LanguageUtil.getLanguage(egret.SysGame.getInstance().gameData.cusSpecies.info.name));
                }
                else {
                    title = egret.LanguageUtil.getLanguage("talent_use_title");
                    content = egret.LanguageUtil.getLanguage(this._skillInfo.fightDesc).replace("%player", egret.LanguageUtil.getLanguage(egret.SysGame.getInstance().gameData.cusSpecies.info.name));
                    content = content.replace("%enemy", this.enemyName);
                }
                this.tfTitle.text = title;
                this.tfContent.text = content;
                this.pic.source = "Event_Risk";
            }
        };
        __egretProto__.onMouseClick = function (evnet) {
            if (evnet === void 0) { evnet = null; }
            if (this.owner)
                this.owner.removeElement(this);
            if (egret.SysGame.getInstance().isPause && egret.SceneUIUtil.curScene.sceneID != egret.SceneUIDef.SCENE_ID_TALENT)
                egret.SysGame.getInstance().isPause = false;
            var needExecute2 = false;
            if (this._fixInfo) {
                if (this._fixInfo.type == 1)
                    needExecute2 = true;
                egret.SysGame.getInstance().excutingFixTips = false;
                this._fixInfo = null;
            }
            if (needExecute2) {
                egret.SysGame.getInstance().executeFixTips(egret.SysGame.getInstance().getFixTipsInfos(2)[0]);
            }
        };
        return RanEventView;
    })(egret.gui.SkinnableComponent);
    egret.RanEventView = RanEventView;
    RanEventView.prototype.__class__ = "egret.RanEventView";
})(egret || (egret = {}));
