var egret;
(function (egret) {
    var ShopItemView = (function (_super) {
        __extends(ShopItemView, _super);
        function ShopItemView() {
            _super.call(this);
            this.skinName = skins.shop.ShopItemSkin;
        }
        var __egretProto__ = ShopItemView.prototype;
        __egretProto__.createChildren = function () {
            _super.prototype.createChildren.call(this);
            egret.LanguageUtil.setLableLanguage(this.tfTitle, "shop_1");
            egret.LanguageUtil.setLableLanguage(this.tfDesc, "shop_2");
            this.btnBuy.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onBuyClick, this);
            this.update();
            egret.SysGame.getInstance().addEventListener(egret.GameEventType.SHOP_BUY, this.onShopBuy, this);
        };
        __egretProto__.update = function () {
            if (this.tfTitle && this.shopItem) {
                this.tfTitle.text = this.shopItem.name;
                this.tfDesc.text = this.shopItem.desc;
                this.tfPrice.text = this.shopItem.price.toString();
                this.icon.source = this.shopItem.info.icon;
                this.onShopBuy();
            }
        };
        __egretProto__.destroy = function () {
            egret.SysGame.getInstance().removeEventListener(egret.GameEventType.SHOP_BUY, this.onShopBuy, this);
        };
        __egretProto__.onBuyClick = function (event) {
            if (!egret.SysGame.getInstance().getShopIsBuy(this.shopItem.info.tabID)) {
                egret.ExternalInterface.call("buyProduct", this.shopItem.info.tabID.toString());
            }
        };
        __egretProto__.onShopBuy = function (event) {
            if (event === void 0) { event = null; }
            if (egret.SysGame.getInstance().getShopIsBuy(this.shopItem.info.tabID)) {
                this.btnBuy.label = egret.LanguageUtil.getLanguage("shop_screen_4");
                this.btnBuy.enabled = false;
            }
            else {
                this.btnBuy.label = egret.LanguageUtil.getLanguage("shop_screen_3");
                this.btnBuy.enabled = true;
            }
        };
        return ShopItemView;
    })(egret.gui.SkinnableComponent);
    egret.ShopItemView = ShopItemView;
    ShopItemView.prototype.__class__ = "egret.ShopItemView";
})(egret || (egret = {}));
