var egret;
(function (egret) {
    var ShopSceneUI = (function (_super) {
        __extends(ShopSceneUI, _super);
        //private curPage:number = 0;
        function ShopSceneUI(sceneID) {
            _super.call(this, sceneID);
            this.skinName = skins.shop.ShopSceneSkin;
            this.shopItems = [];
            this.timer = new egret.Timer(30 * 1000);
            this.timer.addEventListener(egret.TimerEvent.TIMER, this.onTimer, this);
            this.shopMaskCon = new egret.gui.Group();
            this.shopCon = new egret.gui.Group();
            this.shopMaskCon.y = 100;
            this.shopMaskCon.addElement(this.shopCon);
            this.shopMaskCon.mask = new egret.Rectangle(21, 0, 930, 1200);
            egret.ExternalInterface.addCallback("setShopInfo", this.setShopInfo.bind(this));
        }
        var __egretProto__ = ShopSceneUI.prototype;
        __egretProto__.enterScene = function () {
            _super.prototype.enterScene.call(this);
            egret.ExternalInterface.call("getShopInfo", "");
            this.clearShopItem();
            //this.curPage = 0;
            this.timer.start();
            if (this.grpLoading) {
                this.grpLoading.visible = true;
                this.tfLoading.text = egret.LanguageUtil.getLanguage("shop_screen_1");
                this.btnRestore.visible = false;
            }
        };
        __egretProto__.createChildren = function () {
            _super.prototype.createChildren.call(this);
            this.tfTitle.text = egret.LanguageUtil.getLanguage("shop_title");
            this.tfLoading.text = egret.LanguageUtil.getLanguage("shop_screen_1");
            this.btnRestore.label = egret.LanguageUtil.getLanguage("shop_restore");
            this.btnRestore.visible = false;
            this.skin.addElement(this.shopMaskCon);
            this.btnClose.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onCloseTap, this);
            this.btnRestore.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onRestoreTap, this);
            this.addEventListener(egret.TouchEvent.TOUCH_BEGIN, this.onTouchBeg, this);
        };
        __egretProto__.setShopInfo = function (str) {
            var itemStrs = str.split("|");
            var itemID = itemStrs[0];
            var name = itemStrs[1];
            var desc = itemStrs[2];
            var price = itemStrs[3];
            var shopItem = new egret.ShopItem();
            egret.SheetUtil.initShopInfo();
            for (var i = 0; i < egret.SheetUtil.arrShopInfo.length; ++i) {
                var info = egret.SheetUtil.arrShopInfo[i];
                if (info.itemID == itemID) {
                    shopItem.info = info;
                    break;
                }
            }
            shopItem.name = name;
            shopItem.desc = desc;
            shopItem.price = price.trim();
            this.shopItems.push(shopItem);
            this.timer.stop();
            this.timer.reset();
            this.timer.start();
            if (this.shopItems.length == egret.SheetUtil.arrShopInfo.length) {
                this.timer.stop();
                this.updateShopItem();
                this.grpLoading.visible = false;
                this.btnRestore.visible = true;
                this.shopCon.x = 42;
            }
        };
        __egretProto__.updateShopItem = function () {
            var shopItems = this.getShopItemsByPage(0);
            for (var i = 0; i < shopItems.length; ++i) {
                var shopItem = shopItems[i];
                var shopItemView = new egret.ShopItemView();
                shopItemView.update();
                shopItemView.shopItem = shopItem;
                shopItemView.x = (220 + 43) * i;
                this.shopCon.addElement(shopItemView);
            }
        };
        __egretProto__.clearShopItem = function () {
            this.shopItems.length = 0;
            while (this.shopCon.numElements) {
                var shopItemView = this.shopCon.removeElementAt(0);
                shopItemView.destroy();
            }
        };
        __egretProto__.getShopItemsByPage = function (page) {
            //var ary: Array<ShopItem> = [];
            //for (var i: number = page * 3; i < this.shopItems.length || i < (page + 1) * 3; ++i) {
            //    ary.push(this.shopItems[i]);
            //}
            //return ary;
            return this.shopItems;
        };
        __egretProto__.onTimer = function (event) {
            this.timer.stop();
            this.tfLoading.text = egret.LanguageUtil.getLanguage("shop_screen_2");
        };
        __egretProto__.onCloseTap = function (event) {
            egret.SceneUIUtil.runLastScene();
        };
        __egretProto__.onRestoreTap = function (event) {
            egret.ExternalInterface.call("restore", "");
        };
        __egretProto__.onTouchBeg = function (event) {
            this.downPoint = new egret.Point(event.stageX, event.stageY);
            this.downCurX = this.shopCon.x;
            this.addEventListener(egret.TouchEvent.TOUCH_MOVE, this.onTouchMove, this);
            this.addEventListener(egret.TouchEvent.TOUCH_END, this.onTouchEnd, this);
        };
        __egretProto__.onTouchMove = function (event) {
            if (this.downPoint) {
                this.shopCon.x = this.downCurX + event.stageX - this.downPoint.x;
                if (this.shopCon.x > 42) {
                    this.shopCon.x = 42;
                }
                else if (this.shopCon.x + this.shopCon.width < this.width - 30) {
                    this.shopCon.x = this.width - 30 - this.shopCon.width;
                }
            }
        };
        __egretProto__.onTouchEnd = function (event) {
            this.downPoint = null;
            this.removeEventListener(egret.TouchEvent.TOUCH_MOVE, this.onTouchMove, this);
            this.removeEventListener(egret.TouchEvent.TOUCH_END, this.onTouchEnd, this);
        };
        return ShopSceneUI;
    })(BaseSceneUI);
    egret.ShopSceneUI = ShopSceneUI;
    ShopSceneUI.prototype.__class__ = "egret.ShopSceneUI";
})(egret || (egret = {}));
