var egret;
(function (egret) {
    var TalentSceneUI = (function (_super) {
        __extends(TalentSceneUI, _super);
        function TalentSceneUI(sceneID) {
            _super.call(this, sceneID);
            this.needNoEnoughColor = 0xff0000;
            this._gameData = egret.SysGame.getInstance().gameData;
            this.skinName = skins.talentScene.TalentSceneSkin;
            this._talentviews = [];
            egret.ExternalInterface.addCallback("TestExternalInterface", this.testExtFun);
            this._gameData.addEventListener(egret.GameEventType.DNA_CHANGE, this.onDNAChange, this);
            this._gameData.cusSpecies.addEventListener(egret.GameEventType.SPECIES_PRO_CHANGE, this.onSpeciesProChange, this);
            this._gameData.cusSpecies.addEventListener(egret.GameEventType.SPECIES_INFO_CHANGE, this.onSpeciesInfoChange, this);
            egret.SysGame.getInstance().addEventListener(egret.GameEventType.TALENT_ADD, this.onTalentAdd, this);
            egret.SysGame.getInstance().addEventListener(egret.GameEventType.UNLOCK_TALENT, this.onUnlockTalent, this);
        }
        var __egretProto__ = TalentSceneUI.prototype;
        __egretProto__.destroy = function () {
            _super.prototype.destroy.call(this);
            this._gameData.removeEventListener(egret.GameEventType.DNA_CHANGE, this.onDNAChange, this);
            this._gameData.cusSpecies.removeEventListener(egret.GameEventType.SPECIES_PRO_CHANGE, this.onSpeciesProChange, this);
            this._gameData.cusSpecies.removeEventListener(egret.GameEventType.SPECIES_INFO_CHANGE, this.onSpeciesInfoChange, this);
            egret.SysGame.getInstance().removeEventListener(egret.GameEventType.TALENT_ADD, this.onTalentAdd, this);
            egret.SysGame.getInstance().removeEventListener(egret.GameEventType.UNLOCK_TALENT, this.onUnlockTalent, this);
        };
        __egretProto__.enterScene = function () {
            _super.prototype.enterScene.call(this);
            this.checkShopIcon();
        };
        __egretProto__.checkShopIcon = function () {
            if (this.picShopLive) {
                this.picShopLive.visible = egret.SysGame.getInstance().getShopLive() > 0;
                this.picShopSocial.visible = egret.SysGame.getInstance().getShopSocial() > 0;
                this.picShopFight.visible = egret.SysGame.getInstance().getShopFight() > 0;
                this.picShopOverFlag.visible = egret.SysGame.getInstance().getShopIsBuy(4);
            }
        };
        __egretProto__.createChildren = function () {
            _super.prototype.createChildren.call(this);
            this.btnSpcies.label = egret.LanguageUtil.getLanguage("talent_screen_1");
            this.btnHead.label = egret.LanguageUtil.getLanguage("talent_screen_2");
            this.btnBody.label = egret.LanguageUtil.getLanguage("talent_screen_3");
            this.btnLeg.label = egret.LanguageUtil.getLanguage("talent_screen_4");
            egret.LanguageUtil.setLableLanguage(this.tfSpeciesDesc, "talent_1");
            egret.LanguageUtil.setLableLanguage(this.tfSkill1, "talent_1");
            egret.LanguageUtil.setLableLanguage(this.tfSkill2, "talent_1");
            egret.LanguageUtil.setLableLanguage(this.tfSkill3, "talent_1");
            egret.LanguageUtil.setLableLanguage(this.tfSkill4, "talent_1");
            egret.LanguageUtil.setLableLanguage(this.tfAim, "talent_1");
            egret.LanguageUtil.setLableLanguage(this.tfTalentDesc, "talent_2");
            egret.LanguageUtil.setLableLanguage(this.tfTalentEffect1, "talent_3");
            egret.LanguageUtil.setLableLanguage(this.tfTalentEffect1_1, "talent_3");
            egret.LanguageUtil.setLableLanguage(this.tfTalentEffect2, "talent_3");
            egret.LanguageUtil.setLableLanguage(this.tfTalentEffect2_1, "talent_3");
            egret.LanguageUtil.setLableLanguage(this.tfTalentSkill, "talent_3");
            egret.LanguageUtil.setLableLanguage(this.tfTalentSkill_1, "talent_3");
            egret.LanguageUtil.setLableLanguage(this.tfNeedDNA, "talent_3");
            egret.LanguageUtil.setLableLanguage(this.tfNeedDNA_1, "talent_3");
            if (egret.LanguageUtil.lanuage == egret.LanguageUtil.L_CN) {
                this.picLive.source = "ShengCun";
                this.picSocial.source = "SheJiao";
                this.picBreed.source = "FanYan";
            }
            else if (egret.LanguageUtil.lanuage == egret.LanguageUtil.L_EN) {
                this.picLive.source = "ShengCun_en";
                this.picSocial.source = "SheJiao_en";
                this.picBreed.source = "FanYan_en";
            }
            this.barLive = new egret.ProgressBar();
            this.barSocial = new egret.ProgressBar();
            this.barBreed = new egret.ProgressBar();
            this.barLive2 = new egret.ProgressBar();
            this.barSocial2 = new egret.ProgressBar();
            this.barBreed2 = new egret.ProgressBar();
            var begY = 47;
            this.barLive.y = begY;
            this.barSocial.y = begY;
            this.barBreed.y = begY;
            this.barLive2.y = begY;
            this.barSocial2.y = begY;
            this.barBreed2.y = begY;
            this.barLive.x = this.barLive2.x = 287;
            this.barSocial.x = this.barSocial2.x = 527;
            this.barBreed.x = this.barBreed2.x = 752;
            this.barLive2.alpha = 0.5;
            this.barSocial2.alpha = 0.5;
            this.barBreed2.alpha = 0.5;
            this.grpBottom.addElement(this.barLive);
            this.grpBottom.addElement(this.barSocial);
            this.grpBottom.addElement(this.barBreed);
            this.grpBottom.addElement(this.barLive2);
            this.grpBottom.addElement(this.barSocial2);
            this.grpBottom.addElement(this.barBreed2);
            this.grpBottom.addElement(this.picShopLive);
            this.grpBottom.addElement(this.picShopSocial);
            this.tabButtons = [this.btnSpcies, this.btnHead, this.btnBody, this.btnLeg];
            for (var i = 0; i < this.tabButtons.length; i++) {
                var btn = this.tabButtons[i];
                btn.addEventListener(egret.TouchEvent.TOUCH_TAP, this.toggleChangeHandler, this);
            }
            this.btnClose.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onCloseClick, this);
            this.checkShopIcon();
            this.toggleChangeHandler();
            //this.setTalentViews(this.groupHead);
            //this.setTalentViews(this.groupBody);
            //this.setTalentViews(this.groupLeg);
            this.checkTalentViews();
            this.btnTest.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onTestClick, this);
            this.btnEvolution.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onEvolutionClick, this);
            this.barSocial2.setValue(0);
            this.barLive2.setValue(0);
            this.barBreed2.setValue(0);
            this.onDNAChange();
            this.onSpeciesProChange();
            this.onSpeciesInfoChange();
            this.bg.touchEnabled = true;
            this.bg.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onBgClick, this);
            //this.bg2.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onBgClick, this);
            this.bg3.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onBgClick, this);
            this.grpTalentDesc.owner.removeElement(this.grpTalentDesc);
            //this.speciesImg.source = null;
            this.needEnoughColor = this.tfNeedDNA.textColor;
            this.grpTalentDesc.visible = true;
        };
        __egretProto__.onCloseClick = function (event) {
            //SysGame.getInstance().isPause = false;
            egret.SceneUIUtil.runScene(egret.SceneUIDef.SCENE_ID_MAIN);
            this.cancelSelect(false);
        };
        __egretProto__.onTestClick = function (event) {
            //ExternalInterface.call("TestExternalInterface", "");
        };
        __egretProto__.onDNAChange = function (event) {
            if (event === void 0) { event = null; }
            this.tfDNA.text = this._gameData.DNA.toString();
            this.checkEvolutionButton();
        };
        __egretProto__.checkEvolutionButton = function () {
            if (this.curSelTalentView) {
                if (egret.SysGame.getInstance().gameData.DNA >= this.curSelTalentView.talent.info.needDNA + egret.SysGame.getInstance().getShopReduceDNA()) {
                    this.tfNeedDNA.textColor = this.tfNeedDNA_1.textColor = this.needEnoughColor;
                }
                else {
                    this.tfNeedDNA.textColor = this.tfNeedDNA_1.textColor = this.needNoEnoughColor;
                }
                if (this.curSelTalentView.talent.isUnlock && !this.curSelTalentView.talent.isActive && egret.SysGame.getInstance().gameData.DNA >= this.curSelTalentView.talent.info.needDNA + egret.SysGame.getInstance().getShopReduceDNA()) {
                    this.btnEvolution.visible = true;
                }
                else {
                    this.btnEvolution.visible = false;
                }
                if (!this.curSelTalentView.talent.isActive) {
                    this.tfNeedDNA.visible = this.tfNeedDNA_1.visible = true;
                }
                else {
                    this.tfNeedDNA.visible = this.tfNeedDNA_1.visible = false;
                }
            }
        };
        __egretProto__.testExtFun = function (str) {
            egret.gui.Alert.show(str);
        };
        __egretProto__.toggleChangeHandler = function (event) {
            if (event === void 0) { event = null; }
            if (event != null) {
                for (var i = 0; i < this.tabButtons.length; i++) {
                    var btn = this.tabButtons[i];
                    btn.selected = (btn == event.target);
                }
            }
            else {
                this.btnSpcies.selected = true;
            }
            if (this.curSelTalentView) {
                this.cancelSelect(false);
            }
            this.groupBody.visible = false;
            this.groupHead.visible = false;
            this.groupLeg.visible = false;
            this.groupSpcies.visible = false;
            if (this.btnSpcies.selected) {
                this.groupSpcies.visible = true;
                this.curShowGroup = this.groupSpcies;
                this.updateSpecies();
            }
            else if (this.btnHead.selected) {
                this.groupHead.visible = true;
                this.curShowGroup = this.groupHead;
            }
            else if (this.btnBody.selected) {
                this.groupBody.visible = true;
                this.curShowGroup = this.groupBody;
            }
            else if (this.btnLeg.selected) {
                this.groupLeg.visible = true;
                this.curShowGroup = this.groupLeg;
            }
        };
        __egretProto__.checkTalentViews = function () {
            var icon;
            var line;
            var picIndex = 0;
            var talent;
            var talentView;
            var info;
            egret.SheetUtil.initTalentInfo();
            for (var i = 0; i < egret.SheetUtil.arrTalentInfo.length; ++i) {
                info = egret.SheetUtil.arrTalentInfo[i];
                talent = egret.SysGame.getInstance().getTalent(info.tabID);
                icon = this["icon_" + info.picIndex];
                line = this["line_" + info.picIndex];
                talentView = new egret.TalentView(talent, icon, line);
                talentView.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onIconClick, this);
                this._talentviews.push(talentView);
            }
        };
        __egretProto__.onIconClick = function (event) {
            if (event === void 0) { event = null; }
            if (this.curSelTalentView) {
                this.curSelTalentView.selected = false;
            }
            this.curSelTalentView = event.currentTarget;
            this.curSelTalentView.selected = true;
            this.barSocial2.setValue(0);
            this.barLive2.setValue(0);
            this.barBreed2.setValue(0);
            if (!this.curSelTalentView.talent.isActive) {
                if (this.curSelTalentView.talent.info.effect1 == 1) {
                    var breedRateMax = egret.SysGame.getInstance().getCommonValue1(egret.CommonInfoType.breedRateMax);
                    var breedRatePer = (this._gameData.cusSpecies.breedRate + egret.SysGame.getInstance().talentEffect.breedRate + this.curSelTalentView.talent.info.effectValue1) / breedRateMax;
                    this.barBreed2.setValue(breedRatePer * 100);
                }
                else if (this.curSelTalentView.talent.info.effect1 == 2) {
                    var liveMax = egret.SysGame.getInstance().getCommonValue1(egret.CommonInfoType.liveMax);
                    var livePer = (this._gameData.cusSpecies.live + egret.SysGame.getInstance().talentEffect.live + this.curSelTalentView.talent.info.effectValue1) / liveMax;
                    this.barLive2.setValue(livePer * 100);
                }
                else if (this.curSelTalentView.talent.info.effect1 == 3) {
                    var socialMax = egret.SysGame.getInstance().getCommonValue1(egret.CommonInfoType.socialMax);
                    var socialPer = (this._gameData.cusSpecies.social + egret.SysGame.getInstance().talentEffect.social + this.curSelTalentView.talent.info.effectValue1) / socialMax;
                    this.barSocial2.setValue(socialPer * 100);
                }
            }
            this.onDNAChange();
            this.tfTalentName.text = egret.LanguageUtil.getLanguage(this.curSelTalentView.talent.info.name);
            this.tfTalentDesc.text = egret.LanguageUtil.getLanguage(this.curSelTalentView.talent.info.desc);
            this.tfTalentEffect1.text = egret.LanguageUtil.getLanguage("talent_des_left_1");
            this.tfTalentEffect1_1.text = egret.LanguageUtil.getLanguage("talent_des_" + this.curSelTalentView.talent.info.effect1);
            this.tfTalentEffect2.text = egret.LanguageUtil.getLanguage("talent_des_left_2");
            this.tfTalentEffect2_1.text = egret.LanguageUtil.getLanguage("talent_des_" + this.curSelTalentView.talent.info.effect2);
            if (this.curSelTalentView.talent.info.skillID != 0) {
                var skillInfo = egret.SheetUtil.getSkillInfo(this.curSelTalentView.talent.info.skillID);
                this.tfTalentSkill.text = egret.LanguageUtil.getLanguage("talent_des_skill");
                this.tfTalentSkill_1.text = egret.LanguageUtil.getLanguage(skillInfo.name);
            }
            else {
                this.tfTalentSkill.text = "";
                this.tfTalentSkill_1.text = "";
            }
            this.tfNeedDNA.text = egret.LanguageUtil.getLanguage("talent_des_dna");
            var str = this.curSelTalentView.talent.info.needDNA.toString();
            if (egret.SysGame.getInstance().getShopReduceDNA() != 0) {
                str += " (" + egret.SysGame.getInstance().getShopReduceDNA() + ")";
            }
            this.tfNeedDNA_1.text = str;
            if (this.curSelTalentView.talent.isUnlock) {
                this.btnEvolution.label = egret.LanguageUtil.getLanguage("talent_screen_5");
            }
            else {
                this.btnEvolution.label = egret.LanguageUtil.getLanguage("talent_screen_6");
            }
            if (this.curShowGroup.x == 0) {
                egret.Tween.get(this.curShowGroup).to({ x: -263 }, 200);
                this.skin.addElement(this.grpTalentDesc);
                this.grpTalentDesc.x = 980;
                egret.Tween.get(this.grpTalentDesc).to({ x: 660 }, 200);
            }
        };
        __egretProto__.onEvolutionClick = function () {
            var talent = this.curSelTalentView.talent;
            if (!talent.isUnlock) {
                var index = 0;
                if (this.curSelTalentView.talent.info.tabID == 21) {
                    index = 8;
                }
                else if (this.curSelTalentView.talent.info.tabID == 42) {
                    index = 11;
                }
                else if (this.curSelTalentView.talent.info.tabID == 43) {
                    index = 9;
                }
                else if (this.curSelTalentView.talent.info.tabID == 65) {
                    index = 10;
                }
                else if (this.curSelTalentView.talent.info.tabID == 73) {
                    index = 7;
                }
                egret.ExternalInterface.call("buyProduct", index.toString());
            }
            else if (!talent.isActive) {
                if (egret.SysGame.getInstance().gameData.DNA >= talent.info.needDNA + egret.SysGame.getInstance().getShopReduceDNA()) {
                    egret.SysGame.getInstance().gameData.DNA -= talent.info.needDNA + egret.SysGame.getInstance().getShopReduceDNA();
                    talent.isActive = true;
                    egret.SysGame.getInstance().recheckTalentVisible(talent);
                    egret.SysGame.getInstance().executeFixTips(egret.SysGame.getInstance().getFixTipsInfos(5)[0]);
                    egret.SysGame.getInstance().firstClickTalentTime = egret.SysGame.getInstance().gameData.passSec;
                }
            }
        };
        __egretProto__.cancelSelect = function (tween) {
            if (this.curSelTalentView) {
                this.curSelTalentView.selected = false;
                this.curSelTalentView = null;
                if (tween) {
                    egret.Tween.get(this.curShowGroup).to({ x: 0 }, 200);
                    this.grpTalentDesc.x = 660;
                    var group = this.grpTalentDesc;
                    egret.Tween.get(this.grpTalentDesc).to({ x: 980 }, 200).call(function () {
                        group.owner.removeElement(group);
                    });
                }
                else {
                    this.curShowGroup.x = 0;
                    this.grpTalentDesc.x = 660;
                    this.grpTalentDesc.owner.removeElement(this.grpTalentDesc);
                }
                this.barSocial2.setValue(0);
                this.barLive2.setValue(0);
                this.barBreed2.setValue(0);
            }
        };
        __egretProto__.onBgClick = function (event) {
            this.cancelSelect(true);
        };
        __egretProto__.updateSpecies = function () {
            var species = egret.SysGame.getInstance().gameData.cusSpecies.info;
            var skill;
            var colorActive = 0xffffff;
            var colorNoActive = 0x888888;
            this.tfSpeciesTitle.text = egret.LanguageUtil.getLanguage(species.name);
            this.tfSkillTitle.text = egret.LanguageUtil.getLanguage("talent_skill_title");
            this.tfAimTitle.text = egret.LanguageUtil.getLanguage("talent_aim_title");
            this.tfSpeciesDesc.text = egret.LanguageUtil.getLanguage(species.desc);
            skill = egret.SheetUtil.getSkillInfo(species.skill1);
            this.tfSkill1.text = egret.LanguageUtil.getLanguage(skill.name);
            if (egret.SysGame.getInstance().getTalentBySkillID(skill.tabID).isActive) {
                this.tfSkill1.textColor = colorActive;
            }
            else {
                this.tfSkill1.textColor = colorNoActive;
            }
            skill = egret.SheetUtil.getSkillInfo(species.skill2);
            this.tfSkill2.text = egret.LanguageUtil.getLanguage(skill.name);
            if (egret.SysGame.getInstance().getTalentBySkillID(skill.tabID).isActive) {
                this.tfSkill2.textColor = colorActive;
            }
            else {
                this.tfSkill2.textColor = colorNoActive;
            }
            skill = egret.SheetUtil.getSkillInfo(species.skill3);
            this.tfSkill3.text = egret.LanguageUtil.getLanguage(skill.name);
            if (egret.SysGame.getInstance().getTalentBySkillID(skill.tabID).isActive) {
                this.tfSkill3.textColor = colorActive;
            }
            else {
                this.tfSkill3.textColor = colorNoActive;
            }
            skill = egret.SheetUtil.getSkillInfo(species.skill4);
            this.tfSkill4.text = egret.LanguageUtil.getLanguage(skill.name);
            if (egret.SysGame.getInstance().getTalentBySkillID(skill.tabID).isActive) {
                this.tfSkill4.textColor = colorActive;
            }
            else {
                this.tfSkill4.textColor = colorNoActive;
            }
            var modeDiffInfo = egret.SysGame.getInstance().gameData.modeDiffInfo;
            var aimStr = "";
            if (modeDiffInfo.aimType1 == 1) {
                var evoSpeiesInfo;
                if (modeDiffInfo.aimParam1 == 0) {
                    aimStr = egret.LanguageUtil.getLanguage("talent_aim1_any");
                }
                else if (modeDiffInfo.aimParam1 >= 100) {
                    evoSpeiesInfo = egret.SheetUtil.getSpeciesInfo(modeDiffInfo.aimParam1);
                    aimStr = egret.LanguageUtil.getLanguage("talent_aim1_one").replace("%name", egret.LanguageUtil.getLanguage(evoSpeiesInfo.name));
                }
                else {
                    var speciesNames = [];
                    egret.SheetUtil.initEvolutionInfo();
                    for (var e = 0; e < egret.SheetUtil.arrEvolutionInfo.length; ++e) {
                        var evoInfo = egret.SheetUtil.arrEvolutionInfo[e];
                        if (evoInfo.section == modeDiffInfo.aimParam1) {
                            evoSpeiesInfo = egret.SheetUtil.getSpeciesInfo(evoInfo.speciesID);
                            speciesNames.push(egret.LanguageUtil.getLanguage(evoSpeiesInfo.name));
                        }
                    }
                    aimStr = egret.LanguageUtil.getLanguage("talent_aim1_more").replace("%name", speciesNames.join(","));
                }
            }
            else if (modeDiffInfo.aimType1 == 2) {
                aimStr = egret.LanguageUtil.getLanguage("talent_aim2").replace("%number", modeDiffInfo.aimParam1.toString());
            }
            else if (modeDiffInfo.aimType1 == 3) {
                aimStr = egret.LanguageUtil.getLanguage("talent_aim3");
            }
            else if (modeDiffInfo.aimType1 == 4) {
                aimStr = egret.LanguageUtil.getLanguage("talent_aim4").replace("%number", modeDiffInfo.aimParam1.toString());
            }
            this.tfAim.text = aimStr;
        };
        __egretProto__.onSpeciesProChange = function (event) {
            if (event === void 0) { event = null; }
            var socialMax = egret.SysGame.getInstance().getCommonValue1(egret.CommonInfoType.socialMax);
            var liveMax = egret.SysGame.getInstance().getCommonValue1(egret.CommonInfoType.liveMax);
            var breedRateMax = egret.SysGame.getInstance().getCommonValue1(egret.CommonInfoType.breedRateMax);
            var socialPer = (this._gameData.cusSpecies.social + egret.SysGame.getInstance().talentEffect.social) / socialMax;
            var livePer = (this._gameData.cusSpecies.live + egret.SysGame.getInstance().talentEffect.live) / liveMax;
            var breedRatePer = (this._gameData.cusSpecies.breedRate + egret.SysGame.getInstance().talentEffect.breedRate) / breedRateMax;
            this.barSocial.setValue(socialPer * 100);
            this.barLive.setValue(livePer * 100);
            this.barBreed.setValue(breedRatePer * 100);
        };
        __egretProto__.onSpeciesInfoChange = function (event) {
            if (event === void 0) { event = null; }
            this.speciesImg.source = this._gameData.cusSpecies.info.pic;
            this.imgHead.source = this._gameData.cusSpecies.info.imgHead;
            this.imgBody.source = this._gameData.cusSpecies.info.imgBody;
            this.imgLeg.source = this._gameData.cusSpecies.info.imgLeg;
        };
        __egretProto__.onTalentAdd = function (event) {
            if (event === void 0) { event = null; }
            this.onSpeciesProChange();
            this.checkEvolutionButton();
        };
        __egretProto__.onUnlockTalent = function (event) {
            if (event === void 0) { event = null; }
            if (this.curSelTalentView && this.curSelTalentView.talent && this.curSelTalentView.talent.isUnlock) {
                this.btnEvolution.label = egret.LanguageUtil.getLanguage("talent_screen_5");
            }
            else {
                this.btnEvolution.label = egret.LanguageUtil.getLanguage("talent_screen_6");
            }
        };
        return TalentSceneUI;
    })(BaseSceneUI);
    egret.TalentSceneUI = TalentSceneUI;
    TalentSceneUI.prototype.__class__ = "egret.TalentSceneUI";
})(egret || (egret = {}));
